package air.update {
	import air.update.core.UpdaterConfiguration;
	import air.update.core.UpdaterHSM;
	import air.update.core.UpdaterState;
	import air.update.events.DownloadErrorEvent;
	import air.update.events.StatusFileUpdateErrorEvent;
	import air.update.events.StatusFileUpdateEvent;
	import air.update.events.StatusUpdateErrorEvent;
	import air.update.events.StatusUpdateEvent;
	import air.update.events.UpdateEvent;
	import air.update.logging.Logger;
	import air.update.states.HSM;
	import air.update.states.HSMEvent;
	import air.update.states.UpdateState;
	import air.update.utils.Constants;
	import air.update.utils.FileUtils;
	import air.update.utils.VersionUtils;
	import flash.desktop.Updater;
	import flash.events.ErrorEvent;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.events.TimerEvent;
	import flash.filesystem.File;
	import flash.utils.Timer;
	public class ApplicationUpdater extends HSM {
		private static var logger:Logger;
		private static const EVENT_INITIALIZE:String="initialize";
		private static const EVENT_CHECK_URL:String="check.url";
		private static const EVENT_CHECK_FILE:String="check.file";
		protected var configuration:UpdaterConfiguration;
		protected var state:UpdaterState;
		protected var updaterHSM:UpdaterHSM;
		private var _wasPendingUpdate:Boolean;
		private var _isFirstRun:Boolean;
		private var _previousVersion:String;
		private var _previousStorage:File;
		private var installFile:File;
		private var isInitialized:Boolean;
		private var timer:Timer;
		public function ApplicationUpdater();
		protected function stateUninitialized(event:Event):void;
		protected function stateInitializing(event:Event):void;
		protected function stateReady(event:Event):void;
		protected function stateRunning(event:Event):void;
		protected function stateCancelled(event:Event):void;
		public function get updateURL():String;
		public function set updateURL(value:String):void;
		public function get delay():Number;
		public function set delay(value:Number):void;
		public function get configurationFile():File;
		public function set configurationFile(value:File):void;
		public function get updateDescriptor():XML;
		public function get isNewerVersionFunction():Function;
		public function set isNewerVersionFunction(value:Function):void;
		public function get currentState():String;
		public function get isFirstRun():Boolean;
		public function get wasPendingUpdate():Boolean;
		public function get currentVersion():String;
		public function get previousVersion():String;
		public function get previousApplicationStorageDirectory():File;
		public function initialize():void;
		protected function onInitialize():void;
		protected function onInitializationComplete():void;
		public function checkForUpdate():void;
		public function downloadUpdate():void;
		public function installUpdate():void;
		public function cancelUpdate():void;
		public function checkNow():void;
		public function installFromAIRFile(file:File):void;
		protected function handleFirstRun():Boolean;
		protected function handlePeriodicalCheck():void;
		protected function dispatchProxy(event:Event):void;
		protected function onTimer(event:TimerEvent):void;
		protected function onDownloadComplete(event:UpdateEvent):void;
		protected function onFileStatus(event:StatusFileUpdateEvent):void;
		protected function onStateClear(event:Event):void;
		protected function onInstall():void;
		protected function onFileInstall():void;
	}
}
