	package mx.collections {
		import mx.collections.IViewCursor;
		import mx.collections.Sort;
		import flash.events.Event;
		import mx.collections.ICollectionView;
		import mx.collections.errors.CollectionViewError;
		import mx.collections.errors.CursorError;
		import mx.events.CollectionEvent;
		import mx.events.CollectionEventKind;
		import mx.core.mx_internal;
		import mx.resources.IResourceManager;
		import mx.resources.ResourceManager;
		import mx.utils.StringUtil;
		import mx.events.PropertyChangeEvent;
		import flash.utils.Dictionary;
		public class ModifiedCollectionView implements ICollectionView {
			include "../core/Version.as";
			public static const REMOVED:String="removed";
			public static const ADDED:String="added";
			public static const REPLACED:String="replaced";
			public static const REPLACEMENT:String="replacement";
			public function ModifiedCollectionView(list:ICollectionView);
			private var resourceManager:IResourceManager;
			private var list:ICollectionView;
			private var deltaLength:int;
			private var deltas:Array;
			private var removedItems:Dictionary;
			private var addedItems:Dictionary;
			private var replacedItems:Dictionary;
			private var replacementItems:Dictionary;
			public function get length():int;
			public function get filterFunction():Function;
			public function set filterFunction(value:Function):void;
			public function disableAutoUpdate():void;
			public function createCursor():IViewCursor;
			public function contains(item:Object):Boolean;
			public function get sort():Sort;
			public function set sort(value:Sort):void;
			public function itemUpdated(item:Object,property:Object=null,oldValue:Object=null,newValue:Object=null):void;
			public function refresh():Boolean;
			public function enableAutoUpdate():void;
			public function hasEventListener(type:String):Boolean;
			public function willTrigger(type:String):Boolean;
			public function addEventListener(type:String,listener:Function,useCapture:Boolean=false,priority:int=0.0,useWeakReference:Boolean=false):void;
			public function removeEventListener(type:String,listener:Function,useCapture:Boolean=false):void;
			public function dispatchEvent(event:Event):Boolean;
			mx_internal function getBookmark(mcvCursor:ModifiedCollectionViewCursor):ModifiedCollectionViewBookmark;
			mx_internal function getBookmarkIndex(bookmark:CursorBookmark):int;
			private var itemWrappersByIndex:Array;
			private var itemWrappersByCollectionMod:Dictionary;
			mx_internal function getWrappedItemUsingCursor(mcvCursor:ModifiedCollectionViewCursor,newIndex:int):Object;
			private var _showPreserved:Boolean;
			public function get showPreservedState():Boolean;
			public function set showPreservedState(show:Boolean):void;
			public function getSemantics(itemWrapper:ItemWrapper):String;
			public function processCollectionEvent(event:CollectionEvent,startItemIndex:int,endItemIndex:int):void;
			public function removeItem(itemWrapper:ItemWrapper):void;
			public function addItem(itemWrapper:ItemWrapper):void;
			private function isActive(mod:CollectionModification):Boolean;
			private function removeModification(mod:CollectionModification):Boolean;
			private function integrateRemovedElements(event:CollectionEvent,startItemIndex:int,endItemIndex:int):void;
			private function integrateAddedElements(event:CollectionEvent,startItemIndex:int,endItemIndex:int):void;
			private function integrateReplacedElements(event:CollectionEvent,startItemIndex:int,endItemIndex:int):void;
			private function getUniqueItemWrapper(item:Object,mod:CollectionModification,index:int,isReplacement:Boolean=false):Object;
		}
	}
	import mx.collections.ModifiedCollectionView;
	import mx.collections.CursorBookmark;
	import flash.events.EventDispatcher;
	import mx.collections.IViewCursor;
	import mx.events.CollectionEvent;
	import mx.collections.ICollectionView;
	import mx.core.mx_internal;
	import mx.collections.errors.CursorError;
	import mx.collections.errors.CollectionViewError;
	import mx.collections.errors.ItemPendingError;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.events.CollectionEventKind;
	import mx.events.FlexEvent;
	import mx.collections.errors.CursorError;
	import flash.display.InteractiveObject;
	class ModifiedCollectionViewCursor extends EventDispatcher implements IViewCursor {
		private static const BEFORE_FIRST_INDEX:int=-1;
		private static const AFTER_LAST_INDEX:int=-2;
		public function ModifiedCollectionViewCursor(view:ModifiedCollectionView,cursor:IViewCursor,current:Object);
		private var _view:ModifiedCollectionView;
		public var internalCursor:IViewCursor;
		mx_internal var currentIndex:int;
		public var internalIndex:int;
		private var currentValue:Object;
		private var invalid:Boolean;
		private var resourceManager:IResourceManager;
		public function get view():ICollectionView;
		public function get current():Object;
		public function get bookmark():CursorBookmark;
		public function get beforeFirst():Boolean;
		public function get afterLast():Boolean;
		public function findAny(values:Object):Boolean;
		public function findFirst(values:Object):Boolean;
		public function findLast(values:Object):Boolean;
		public function insert(item:Object):void;
		public function moveNext():Boolean;
		public function movePrevious():Boolean;
		public function remove():Object;
		public function seek(bookmark:CursorBookmark,offset:int=0,prefetch:int=0):void;
		private function checkValid():void;
		private function setCurrent(value:Object,dispatch:Boolean=true):void;
	}
	class ModifiedCollectionViewBookmark extends CursorBookmark {
		mx_internal var index:int;
		mx_internal var view:ModifiedCollectionView;
		mx_internal var viewRevision:int;
		mx_internal var internalBookmark:CursorBookmark;
		mx_internal var internalIndex:int;
		public function ModifiedCollectionViewBookmark(value:Object,view:ModifiedCollectionView,viewRevision:int,index:int,internalBookmark:CursorBookmark,internalIndex:int);
		override public function getViewIndex():int;
	}
	class CollectionModification {
		public static const REMOVE:String="remove";
		public static const ADD:String="add";
		public static const REPLACE:String="replace";
		public function CollectionModification(index:int,item:Object,modificationType:String);
		public var index:int;
		public var item:Object;
		public var modificationType:String;
		private var _modCount:int;
		public var showOldReplace:Boolean;
		public var showNewReplace:Boolean;
		public function get isRemove():Boolean;
		public function startShowingReplacementValue():void;
		public function stopShowingReplacedValue():void;
		public function get modCount():int;
	}
