package mx.containers {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.ui.Keyboard;
	import flash.utils.getTimer;
	import mx.automation.IAutomationObject;
	import mx.containers.accordionClasses.AccordionHeader;
	import mx.controls.Button;
	import mx.core.ClassFactory;
	import mx.core.ComponentDescriptor;
	import mx.core.Container;
	import mx.core.ContainerCreationPolicy;
	import mx.core.EdgeMetrics;
	import mx.core.FlexVersion;
	import mx.core.IDataRenderer;
	import mx.core.IFactory;
	import mx.managers.IFocusManagerComponent;
	import mx.managers.IHistoryManagerClient;
	import mx.core.IInvalidating;
	import mx.core.IUIComponent;
	import mx.core.ScrollPolicy;
	import mx.core.UIComponent;
	import mx.core.mx_internal;
	import mx.effects.Effect;
	import mx.effects.Tween;
	import mx.events.ChildExistenceChangedEvent;
	import mx.events.FlexEvent;
	import mx.events.IndexChangedEvent;
	import mx.graphics.RoundedRectangle;
	import mx.managers.HistoryManager;
	import mx.styles.StyleManager;
	import mx.styles.CSSStyleDeclaration;
	import mx.styles.StyleProxy;
	public class Accordion extends Container implements IHistoryManagerClient, IFocusManagerComponent {
		include "../core/Version.as";
		private static const HEADER_NAME_BASE:String="_header";
		public function Accordion();
		private var bSliding:Boolean;
		private var initialSelectedIndex:int;
		private var bSaveState:Boolean;
		private var bInLoadState:Boolean;
		private var firstTime:Boolean;
		private var showFocusIndicator:Boolean;
		private var tweenViewMetrics:EdgeMetrics;
		private var tweenContentWidth:Number;
		private var tweenContentHeight:Number;
		private var tweenOldSelectedIndex:int;
		private var tweenNewSelectedIndex:int;
		private var tween:Tween;
		private var accMinWidth:Number;
		private var accMinHeight:Number;
		private var accPreferredWidth:Number;
		private var accPreferredHeight:Number;
		private var childAddedOrRemoved:Boolean;
		private var overlayChild:IUIComponent;
		private var overlayTargetArea:RoundedRectangle;
		private var layoutStyleChanged:Boolean;
		private var currentDissolveEffect:Effect;
		override public function get autoLayout():Boolean;
		override public function set autoLayout(value:Boolean):void;
		override public function get baselinePosition():Number;
		override public function get clipContent():Boolean;
		override public function set clipContent(value:Boolean):void;
		override public function get horizontalScrollPolicy():String;
		override public function set horizontalScrollPolicy(value:String):void;
		override public function get verticalScrollPolicy():String;
		override public function set verticalScrollPolicy(value:String):void;
		private var _focusedIndex:int;
		mx_internal function get focusedIndex():int;
		protected function get contentHeight():Number;
		protected function get contentWidth():Number;
		private var _headerRenderer:IFactory;
		public function get headerRenderer():IFactory;
		public function set headerRenderer(value:IFactory):void;
		private var _historyManagementEnabled:Boolean;
		private var historyManagementEnabledChanged:Boolean;
		public function get historyManagementEnabled():Boolean;
		public function set historyManagementEnabled(value:Boolean):void;
		private var _resizeToContent:Boolean;
		public function get resizeToContent():Boolean;
		public function set resizeToContent(value:Boolean):void;
		public function get selectedChild():Container;
		public function set selectedChild(value:Container):void;
		private var _selectedIndex:int;
		private var proposedSelectedIndex:int;
		public function get selectedIndex():int;
		public function set selectedIndex(value:int):void;
		override public function createComponentsFromDescriptors(recurse:Boolean=true):void;
		override public function setChildIndex(child:DisplayObject,newIndex:int):void;
		private function shuffleHeaders(oldIndex:int,newIndex:int):void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override mx_internal function setActualCreationPolicies(policy:String):void;
		override protected function focusInHandler(event:FocusEvent):void;
		override protected function focusOutHandler(event:FocusEvent):void;
		override public function drawFocus(isFocused:Boolean):void;
		override public function styleChanged(styleProp:String):void;
		override mx_internal function addOverlay(color:uint,targetArea:RoundedRectangle=null):void;
		private function initializeHandler(event:FlexEvent):void;
		override mx_internal function removeOverlay():void;
		public function saveState():Object;
		public function loadState(state:Object):void;
		public function getHeaderAt(index:int):Button;
		private function getHeaderHeight():Number;
		private function createHeader(content:DisplayObject,i:int):void;
		private function calcContentWidth():Number;
		private function calcContentHeight():Number;
		private function drawHeaderFocus(headerIndex:int,isFocused:Boolean):void;
		private function headerClickHandler(event:Event):void;
		private function commitSelectedIndex():void;
		private function instantiateChild(child:Container):void;
		private function dispatchChangeEvent(oldIndex:int,newIndex:int,cause:Event=null):void;
		private function startTween(oldSelectedIndex:int,newSelectedIndex:int):void;
		mx_internal function onTweenUpdate(value:Number):void;
		mx_internal function onTweenEnd(value:Number):void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		private function addedToStageHandler(event:Event):void;
		private function removedFromStageHandler(event:Event):void;
		private function childAddHandler(event:ChildExistenceChangedEvent):void;
		private function childRemoveHandler(event:ChildExistenceChangedEvent):void;
		private function labelChangedHandler(event:Event):void;
		private function iconChangedHandler(event:Event):void;
	}
}
