	package mx.containers.utilityClasses {
		import flash.display.DisplayObject;
		import flash.geom.Rectangle;
		import mx.containers.Canvas;
		import mx.containers.errors.ConstraintError;
		import mx.core.Container;
		import mx.core.EdgeMetrics;
		import mx.core.FlexVersion;
		import mx.core.IConstraintClient;
		import mx.core.IUIComponent;
		import mx.core.mx_internal;
		import mx.events.ChildExistenceChangedEvent;
		import mx.events.MoveEvent;
		import mx.resources.IResourceManager;
		import mx.resources.ResourceManager;
		import mx.styles.StyleManager;
		import flash.utils.Dictionary;
		public class CanvasLayout extends Layout {
			include "../../core/Version.as";
			private static var r:Rectangle;
			private function bound(a:Number,min:Number,max:Number):Number;
			private var _contentArea:Rectangle;
			private var colSpanChildren:Array;
			private var rowSpanChildren:Array;
			private var constraintCache:Dictionary;
			private var constraintRegionsInUse:Boolean;
			public function CanvasLayout();
			override public function set target(value:Container):void;
			override public function measure():void;
			override public function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
			private function applyAnchorStylesDuringMeasure(child:IUIComponent,r:Rectangle):void;
			private function applyAnchorStylesDuringUpdateDisplayList(availableWidth:Number,availableHeight:Number,child:IUIComponent=null):void;
			private function measureContentArea():Rectangle;
			private function parseConstraints(child:IUIComponent=null):ChildConstraintInfo;
			private function measureColumnsAndRows():void;
			private function shareColumnSpace(entry:ContentColumnChild,availableWidth:Number):Number;
			private function shareRowSpace(entry:ContentRowChild,availableHeight:Number):Number;
			private function getLayoutConstraints(child:IUIComponent):LayoutConstraints;
			private function parseConstraintExp(val:String):Array;
			private function target_childAddHandler(event:ChildExistenceChangedEvent):void;
			private function target_childRemoveHandler(event:ChildExistenceChangedEvent):void;
			private function child_moveHandler(event:MoveEvent):void;
		}
	}
	import mx.containers.utilityClasses.ConstraintColumn;
	import mx.core.IUIComponent;
	import mx.containers.utilityClasses.ConstraintRow;
	class ChildConstraintInfo {
		public function ChildConstraintInfo(left:Number,right:Number,hc:Number,top:Number,bottom:Number,vc:Number,baseline:Number,leftBoundary:String=null,rightBoundary:String=null,hcBoundary:String=null,topBoundary:String=null,bottomBoundary:String=null,vcBoundary:String=null,baselineBoundary:String=null):void;
		public var left:Number;
		public var right:Number;
		public var hc:Number;
		public var top:Number;
		public var bottom:Number;
		public var vc:Number;
		public var baseline:Number;
		public var leftBoundary:String;
		public var rightBoundary:String;
		public var hcBoundary:String;
		public var topBoundary:String;
		public var bottomBoundary:String;
		public var vcBoundary:String;
		public var baselineBoundary:String;
	}
	class ContentColumnChild {
		public function ContentColumnChild():void;
		public var leftCol:ConstraintColumn;
		public var leftOffset:Number;
		public var left:Number;
		public var rightCol:ConstraintColumn;
		public var rightOffset:Number;
		public var right:Number;
		public var hcCol:ConstraintColumn;
		public var hcOffset:Number;
		public var hc:Number;
		public var child:IUIComponent;
		public var span:Number;
	}
	class ContentRowChild {
		public function ContentRowChild():void;
		public var topRow:ConstraintRow;
		public var topOffset:Number;
		public var top:Number;
		public var bottomRow:ConstraintRow;
		public var bottomOffset:Number;
		public var bottom:Number;
		public var vcRow:ConstraintRow;
		public var vcOffset:Number;
		public var vc:Number;
		public var baselineRow:ConstraintRow;
		public var baselineOffset:Number;
		public var baseline:Number;
		public var child:IUIComponent;
		public var span:Number;
	}
	class LayoutConstraints {
		public function LayoutConstraints():void;
		public var baseline:*;
		public var bottom:*;
		public var horizontalCenter:*;
		public var left:*;
		public var right:*;
		public var top:*;
		public var verticalCenter:*;
	}
