package mx.controls {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.GradientType;
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Keyboard;
	import flash.utils.describeType;
	import flash.utils.Dictionary;
	import mx.collections.CursorBookmark;
	import mx.collections.ICollectionView;
	import mx.collections.ItemResponder;
	import mx.collections.Sort;
	import mx.collections.SortField;
	import mx.collections.errors.ItemPendingError;
	import mx.controls.dataGridClasses.DataGridBase;
	import mx.controls.dataGridClasses.DataGridColumn;
	import mx.controls.dataGridClasses.DataGridDragProxy;
	import mx.controls.dataGridClasses.DataGridHeader;
	import mx.controls.dataGridClasses.DataGridItemRenderer;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.controls.listClasses.ListBaseContentHolder;
	import mx.controls.listClasses.ListBaseSeekPending;
	import mx.controls.listClasses.ListRowInfo;
	import mx.controls.scrollClasses.ScrollBar;
	import mx.core.ContextualClassFactory;
	import mx.core.EdgeMetrics;
	import mx.core.EventPriority;
	import mx.core.FlexShape;
	import mx.core.FlexSprite;
	import mx.core.FlexVersion;
	import mx.core.IChildList;
	import mx.core.IFactory;
	import mx.core.IFlexDisplayObject;
	import mx.core.IIMESupport;
	import mx.core.IInvalidating;
	import mx.core.IPropertyChangeNotifier;
	import mx.core.IRawChildrenContainer;
	import mx.core.IRectangularBorder;
	import mx.core.IUIComponent;
	import mx.core.ScrollPolicy;
	import mx.core.UIComponent;
	import mx.core.UIComponentGlobals;
	import mx.core.mx_internal;
	import mx.events.CollectionEvent;
	import mx.events.CollectionEventKind;
	import mx.events.ListEvent;
	import mx.events.DataGridEvent;
	import mx.events.DataGridEventReason;
	import mx.events.DragEvent;
	import mx.events.FlexEvent;
	import mx.events.IndexChangedEvent;
	import mx.events.SandboxMouseEvent;
	import mx.events.ScrollEvent;
	import mx.events.ScrollEventDetail;
	import mx.managers.CursorManager;
	import mx.managers.CursorManagerPriority;
	import mx.managers.IFocusManager;
	import mx.managers.IFocusManagerComponent;
	import mx.managers.ISystemManager;
	import mx.skins.halo.ListDropIndicator;
	import mx.styles.ISimpleStyleClient;
	import mx.styles.StyleManager;
	import mx.utils.ObjectUtil;
	import mx.managers.ISystemManager;
	import mx.core.IFlexModuleFactory;
	import mx.utils.StringUtil;
	include "../styles/metadata/IconColorStyles.as";
	public class DataGrid extends DataGridBase implements IIMESupport {
		include "../core/Version.as";
		mx_internal static var createAccessibilityImplementation:Function;
		public function DataGrid();
		public var itemEditorInstance:IListItemRenderer;
		public function get editedItemRenderer():IListItemRenderer;
		private var skipHeaderUpdate:Boolean;
		private var dontEdit:Boolean;
		private var losingFocus:Boolean;
		private var inEndEdit:Boolean;
		private var collectionUpdatesDisabled:Boolean;
		mx_internal var sortIndex:int;
		private var sortColumn:DataGridColumn;
		mx_internal var sortDirection:String;
		mx_internal var lastSortIndex:int;
		private var lastItemDown:IListItemRenderer;
		private var displayWidth:Number;
		private var lockedColumnWidth:Number;
		mx_internal var movingColumn:DataGridColumn;
		mx_internal var resizingColumn:DataGridColumn;
		private var displayableColumns:Array;
		private var generatedColumns:Boolean;
		private var actualRowIndex:int;
		private var actualColIndex:int;
		private var actualContentHolder:ListBaseContentHolder;
		private var manualSort:Boolean;
		override public function get baselinePosition():Number;
		override public function get columnCount():int;
		override public function set enabled(value:Boolean):void;
		override public function set headerHeight(value:Number):void;
		override public function set horizontalScrollPosition(value:Number):void;
		override public function set horizontalScrollPolicy(value:String):void;
		override public function set verticalScrollPosition(value:Number):void;
		override protected function createChildren():void;
		private var _imeMode:String;
		public function get imeMode():String;
		public function set imeMode(value:String):void;
		override public function get itemRenderer():IFactory;
		private var _minColumnWidth:Number;
		private var minColumnWidthInvalid:Boolean;
		public function get minColumnWidth():Number;
		public function set minColumnWidth(value:Number):void;
		private var _columns:Array;
		override public function get columns():Array;
		override public function set columns(value:Array):void;
		private var _draggableColumns:Boolean;
		public function get draggableColumns():Boolean;
		public function set draggableColumns(value:Boolean):void;
		public var editable:Boolean;
		private var bEditedItemPositionChanged:Boolean;
		private var _proposedEditedItemPosition:*;
		private var lastEditedItemPosition:*;
		private var _editedItemPosition:Object;
		private var itemEditorPositionChanged:Boolean;
		public function get editedItemPosition():Object;
		public function set editedItemPosition(value:Object):void;
		public var resizableColumns:Boolean;
		public var sortableColumns:Boolean;
		override public function invalidateDisplayList():void;
		override public function set dataProvider(value:Object):void;
		override protected function initializeAccessibility():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override protected function makeRowsAndColumns(left:Number,top:Number,right:Number,bottom:Number,firstCol:int,firstRow:int,byCount:Boolean=false,rowsNeeded:uint=0):Point;
		override protected function commitProperties():void;
		override public function measureWidthOfItems(index:int=-1,count:int=0):Number;
		mx_internal function setupRendererFromData(c:DataGridColumn,item:IListItemRenderer,data:Object):void;
		override public function measureHeightOfItems(index:int=-1,count:int=0):Number;
		mx_internal function measureHeightOfItemsUptoMaxHeight(index:int=-1,count:int=0,maxHeight:Number=-1):Number;
		mx_internal function calculateHeaderHeight():Number;
		private var _headerWordWrapPresent:Boolean;
		private var _originalExplicitHeaderHeight:Boolean;
		private var _originalHeaderHeight:Number;
		override protected function calculateRowHeight(data:Object,hh:Number,skipVisible:Boolean=false):Number;
		override protected function scrollHandler(event:Event):void;
		private function displayingPartialRow():Boolean;
		override protected function configureScrollBars():void;
		private function adjustVerticalScrollPositionDownward(rowCount:int):Boolean;
		override public function calculateDropIndex(event:DragEvent=null):int;
		override protected function drawRowBackgrounds():void;
		protected function drawRowGraphics(contentHolder:ListBaseContentHolder):void;
		override protected function mouseEventToItemRenderer(event:MouseEvent):IListItemRenderer;
		override protected function get dragImage():IUIComponent;
		mx_internal function shiftColumns(oldIndex:int,newIndex:int,trigger:Event=null):void;
		private function generateCols():void;
		private function generateColumnsPendingResultHandler(data:Object,info:ListBaseSeekPending):void;
		private function calculateColumnSizes():void;
		override mx_internal function resizeColumn(col:int,w:Number):void;
		protected function drawRowBackground(s:Sprite,rowIndex:int,y:Number,height:Number,color:uint,dataIndex:int):void;
		protected function drawColumnBackground(s:Sprite,columnIndex:int,color:uint,column:DataGridColumn):void;
		private function drawHorizontalSeparator(s:Sprite,rowIndex:int,color:uint,y:Number,useLockedSeparator:Boolean=false):void;
		protected function drawHorizontalLine(s:Sprite,rowIndex:int,color:uint,y:Number):void;
		private function drawVerticalSeparator(s:Sprite,colIndex:int,color:uint,x:Number,useLockedSeparator:Boolean=false):void;
		protected function drawVerticalLine(s:Sprite,colIndex:int,color:uint,x:Number):void;
		protected function drawLinesAndColumnBackgrounds():void;
		protected function drawLinesAndColumnGraphics(contentHolder:ListBaseContentHolder,visibleColumns:Array,separators:Object):void;
		mx_internal function _drawHeaderBackground(headerBG:UIComponent):void;
		protected function drawHeaderBackground(headerBG:UIComponent):void;
		mx_internal function _clearSeparators():void;
		protected function clearSeparators():void;
		mx_internal function _drawSeparators():void;
		protected function drawSeparators():void;
		private function updateSortIndexAndDirection():void;
		mx_internal function _placeSortArrow():void;
		protected function placeSortArrow():void;
		private function sortByColumn(index:int):void;
		private function setEditedItemPosition(coord:Object):void;
		private function commitEditedItemPosition(coord:Object):void;
		private function scrollToEditedItem(rowIndex:int,colIndex:int):void;
		public function createItemEditor(colIndex:int,rowIndex:int):void;
		private function findNextItemRenderer(shiftKey:Boolean):Boolean;
		public function destroyItemEditor():void;
		private function endEdit(reason:String):Boolean;
		public function isItemEditable(data:Object):Boolean;
		override mx_internal function columnRendererChanged(c:DataGridColumn):void;
		override protected function collectionChangeHandler(event:Event):void;
		override protected function mouseDownHandler(event:MouseEvent):void;
		override protected function mouseUpHandler(event:MouseEvent):void;
		override protected function focusInHandler(event:FocusEvent):void;
		override protected function focusOutHandler(event:FocusEvent):void;
		private function deactivateHandler(event:Event):void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		override public function itemToLabel(data:Object):String;
		private function editorMouseDownHandler(event:Event):void;
		private function editorKeyDownHandler(event:KeyboardEvent):void;
		private function editorStageResizeHandler(event:Event):void;
		private function findNextEnterItemRenderer(event:KeyboardEvent):void;
		private function mouseFocusChangeHandler(event:MouseEvent):void;
		private function keyFocusChangeHandler(event:FocusEvent):void;
		private function itemEditorFocusOutHandler(event:FocusEvent):void;
		private function itemEditorItemEditBeginningHandler(event:DataGridEvent):void;
		private function itemEditorItemEditBeginHandler(event:DataGridEvent):void;
		private function itemEditorItemEditEndHandler(event:DataGridEvent):void;
		private function headerReleaseHandler(event:DataGridEvent):void;
		override protected function mouseWheelHandler(event:MouseEvent):void;
		override protected function dragStartHandler(event:DragEvent):void;
		mx_internal function get vScrollBar():ScrollBar;
		override mx_internal function get rendererArray():Array;
		mx_internal function get sortArrow():IFlexDisplayObject;
		override protected function adjustListContent(unscaledWidth:Number=-1,unscaledHeight:Number=-1):void;
		private function lockedRowSeekPendingResultHandler(data:Object,info:ListBaseSeekPending):void;
		override protected function scrollPositionToIndex(horizontalScrollPosition:int,verticalScrollPosition:int):int;
		override protected function scrollVertically(pos:int,deltaPos:int,scrollUp:Boolean):void;
		private var _focusPane:Sprite;
		override public function set focusPane(value:Sprite):void;
		mx_internal var lockedColumnDropIndicator:IFlexDisplayObject;
		override public function showDropFeedback(event:DragEvent):void;
		override public function hideDropFeedback(event:DragEvent):void;
	}
}
