package mx.controls {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	import flash.utils.Dictionary;
	import mx.collections.CursorBookmark;
	import mx.collections.IList;
	import mx.collections.ItemResponder;
	import mx.collections.errors.ItemPendingError;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.controls.listClasses.ListBase;
	import mx.controls.listClasses.ListBaseContentHolder;
	import mx.controls.listClasses.ListBaseSeekPending;
	import mx.controls.listClasses.ListData;
	import mx.controls.listClasses.ListItemRenderer;
	import mx.controls.listClasses.ListRowInfo;
	import mx.controls.scrollClasses.ScrollBar;
	import mx.core.ClassFactory;
	import mx.core.EdgeMetrics;
	import mx.core.EventPriority;
	import mx.core.FlexShape;
	import mx.core.FlexSprite;
	import mx.core.FlexVersion;
	import mx.core.IChildList;
	import mx.core.IFactory;
	import mx.core.IIMESupport;
	import mx.core.IInvalidating;
	import mx.core.IPropertyChangeNotifier;
	import mx.core.IRawChildrenContainer;
	import mx.core.ScrollPolicy;
	import mx.core.UIComponent;
	import mx.core.UIComponentGlobals;
	import mx.core.mx_internal;
	import mx.events.CollectionEvent;
	import mx.events.CollectionEventKind;
	import mx.events.ListEvent;
	import mx.events.ListEventReason;
	import mx.events.SandboxMouseEvent;
	import mx.events.ScrollEvent;
	import mx.events.ScrollEventDetail;
	import mx.managers.IFocusManager;
	import mx.managers.IFocusManagerComponent;
	import mx.managers.ISystemManager;
	import mx.styles.StyleManager;
	import mx.collections.ItemWrapper;
	import mx.collections.ModifiedCollectionView;
	import mx.core.IUIComponent;
	public class List extends ListBase implements IIMESupport {
		include "../core/Version.as";
		mx_internal static var createAccessibilityImplementation:Function;
		public function List();
		public var itemEditorInstance:IListItemRenderer;
		public function get editedItemRenderer():IListItemRenderer;
		private var dontEdit:Boolean;
		private var losingFocus:Boolean;
		private var inEndEdit:Boolean;
		private var actualRowIndex:int;
		private var actualColIndex:int;
		protected var measuringObjects:Dictionary;
		override public function get baselinePosition():Number;
		override public function set maxHorizontalScrollPosition(value:Number):void;
		public var editable:Boolean;
		public var itemEditor:IFactory;
		public var editorDataField:String;
		public var editorHeightOffset:Number;
		public var editorWidthOffset:Number;
		public var editorXOffset:Number;
		public var editorYOffset:Number;
		public var editorUsesEnterKey:Boolean;
		override public function set enabled(value:Boolean):void;
		private var bEditedItemPositionChanged:Boolean;
		private var _proposedEditedItemPosition:*;
		private var lastEditedItemPosition:*;
		private var _editedItemPosition:Object;
		public function get editedItemPosition():Object;
		public function set editedItemPosition(value:Object):void;
		mx_internal var _lockedRowCount:int;
		public function get lockedRowCount():int;
		public function set lockedRowCount(value:int):void;
		public var rendererIsEditor:Boolean;
		private var _imeMode:String;
		public function get imeMode():String;
		public function set imeMode(value:String):void;
		override public function set dataProvider(value:Object):void;
		override protected function initializeAccessibility():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function configureScrollBars():void;
		private function adjustVerticalScrollPositionDownward(rowCount:int):Boolean;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override protected function adjustListContent(unscaledWidth:Number=-1,unscaledHeight:Number=-1):void;
		override protected function drawRowBackgrounds():void;
		protected function drawRowBackground(s:Sprite,rowIndex:int,y:Number,height:Number,color:uint,dataIndex:int):void;
		override protected function makeRowsAndColumns(left:Number,top:Number,right:Number,bottom:Number,firstCol:int,firstRow:int,byCount:Boolean=false,rowsNeeded:uint=0):Point;
		protected function layoutEditor(x:int,y:int,w:int,h:int):void;
		override protected function scrollHandler(event:Event):void;
		override protected function scrollHorizontally(pos:int,deltaPos:int,scrollUp:Boolean):void;
		protected function makeListData(data:Object,uid:String,rowNum:int):BaseListData;
		mx_internal function setupRendererFromData(item:IListItemRenderer,wrappedData:Object):void;
		override public function measureWidthOfItems(index:int=-1,count:int=0):Number;
		override public function measureHeightOfItems(index:int=-1,count:int=0):Number;
		override protected function mouseEventToItemRenderer(event:MouseEvent):IListItemRenderer;
		mx_internal function getMeasuringRenderer(data:Object):IListItemRenderer;
		mx_internal function purgeMeasuringRenderers():void;
		override public function set itemRenderer(value:IFactory):void;
		override public function createItemRenderer(data:Object):IListItemRenderer;
		private function editingTemporarilyPrevented(coord:Object):Boolean;
		private function setEditedItemPosition(coord:Object):void;
		private function commitEditedItemPosition(coord:Object):void;
		public function createItemEditor(colIndex:int,rowIndex:int):void;
		private function findNextItemRenderer(shiftKey:Boolean):Boolean;
		public function destroyItemEditor():void;
		protected function endEdit(reason:String):Boolean;
		public function isItemEditable(data:Object):Boolean;
		override protected function mouseDownHandler(event:MouseEvent):void;
		override protected function mouseUpHandler(event:MouseEvent):void;
		override protected function focusInHandler(event:FocusEvent):void;
		override protected function focusOutHandler(event:FocusEvent):void;
		private function deactivateHandler(event:Event):void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		private function editorMouseDownHandler(event:Event):void;
		private function editorKeyDownHandler(event:KeyboardEvent):void;
		private function findNextEnterItemRenderer(event:KeyboardEvent):void;
		private function mouseFocusChangeHandler(event:MouseEvent):void;
		private function keyFocusChangeHandler(event:FocusEvent):void;
		private function itemEditorFocusOutHandler(event:FocusEvent):void;
		private function itemEditorItemEditBeginningHandler(event:ListEvent):void;
		private function itemEditorItemEditBeginHandler(event:ListEvent):void;
		private function itemEditorItemEditEndHandler(event:ListEvent):void;
		override protected function drawHighlightIndicator(indicator:Sprite,x:Number,y:Number,width:Number,height:Number,color:uint,itemRenderer:IListItemRenderer):void;
		override protected function drawCaretIndicator(indicator:Sprite,x:Number,y:Number,width:Number,height:Number,color:uint,itemRenderer:IListItemRenderer):void;
		override protected function drawSelectionIndicator(indicator:Sprite,x:Number,y:Number,width:Number,height:Number,color:uint,itemRenderer:IListItemRenderer):void;
		override protected function mouseWheelHandler(event:MouseEvent):void;
		override protected function collectionChangeHandler(event:Event):void;
		mx_internal function callSetupRendererFromData(item:IListItemRenderer,data:Object):void;
		mx_internal function callMakeListData(data:Object,uid:String,rowNum:int):BaseListData;
	}
}
