package mx.controls {
	import flash.accessibility.AccessibilityProperties;
	import flash.display.DisplayObject;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.TextEvent;
	import flash.system.IME;
	import flash.system.IMEConversionMode;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.text.TextLineMetrics;
	import flash.ui.Keyboard;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.core.EdgeMetrics;
	import mx.core.FlexVersion;
	import mx.core.IDataRenderer;
	import mx.core.IFlexDisplayObject;
	import mx.core.IFlexModuleFactory;
	import mx.core.IFontContextComponent;
	import mx.core.IIMESupport;
	import mx.core.IInvalidating;
	import mx.core.IRectangularBorder;
	import mx.core.IUITextField;
	import mx.core.UIComponent;
	import mx.core.UITextField;
	import mx.core.mx_internal;
	import mx.events.FlexEvent;
	import mx.managers.IFocusManager;
	import mx.managers.IFocusManagerComponent;
	import mx.managers.ISystemManager;
	import mx.managers.SystemManager;
	import mx.styles.ISimpleStyleClient;
	include "../styles/metadata/BorderStyles.as";
	include "../styles/metadata/FocusStyles.as";
	include "../styles/metadata/PaddingStyles.as";
	include "../styles/metadata/TextStyles.as";
	public class TextInput extends UIComponent implements IDataRenderer, IDropInListItemRenderer, IFocusManagerComponent, IIMESupport, IListItemRenderer, IFontContextComponent {
		include "../core/Version.as";
		public function TextInput();
		mx_internal var border:IFlexDisplayObject;
		private var textSet:Boolean;
		private var selectionChanged:Boolean;
		mx_internal var parentDrawsFocus:Boolean;
		private var prevMode:String;
		private var errorCaught:Boolean;
		private var _accessibilityProperties:AccessibilityProperties;
		private var accessibilityPropertiesChanged:Boolean;
		override public function get accessibilityProperties():AccessibilityProperties;
		override public function set accessibilityProperties(value:AccessibilityProperties):void;
		override public function get baselinePosition():Number;
		private var enabledChanged:Boolean;
		override public function set enabled(value:Boolean):void;
		public function get fontContext():IFlexModuleFactory;
		public function set fontContext(moduleFactory:IFlexModuleFactory):void;
		private var _tabIndex:int;
		private var tabIndexChanged:Boolean;
		override public function get tabIndex():int;
		override public function set tabIndex(value:int):void;
		private var _condenseWhite:Boolean;
		private var condenseWhiteChanged:Boolean;
		public function get condenseWhite():Boolean;
		public function set condenseWhite(value:Boolean):void;
		private var _data:Object;
		public function get data():Object;
		public function set data(value:Object):void;
		private var _displayAsPassword:Boolean;
		private var displayAsPasswordChanged:Boolean;
		public function get displayAsPassword():Boolean;
		public function set displayAsPassword(value:Boolean):void;
		private var _editable:Boolean;
		private var editableChanged:Boolean;
		public function get editable():Boolean;
		public function set editable(value:Boolean):void;
		private var _horizontalScrollPosition:Number;
		private var horizontalScrollPositionChanged:Boolean;
		public function get horizontalScrollPosition():Number;
		public function set horizontalScrollPosition(value:Number):void;
		private var _htmlText:String;
		private var htmlTextChanged:Boolean;
		private var explicitHTMLText:String;
		public function get htmlText():String;
		public function set htmlText(value:String):void;
		private var _imeMode:String;
		public function get imeMode():String;
		public function set imeMode(value:String):void;
		private function get isHTML():Boolean;
		public function get length():int;
		private var _listData:BaseListData;
		public function get listData():BaseListData;
		public function set listData(value:BaseListData):void;
		private var _maxChars:int;
		private var maxCharsChanged:Boolean;
		public function get maxChars():int;
		public function set maxChars(value:int):void;
		public function get maxHorizontalScrollPosition():Number;
		private var _restrict:String;
		private var restrictChanged:Boolean;
		public function get restrict():String;
		public function set restrict(value:String):void;
		private var _selectable:Boolean;
		private var selectableChanged:Boolean;
		mx_internal function get selectable():Boolean;
		mx_internal function set selectable(value:Boolean):void;
		private var _selectionBeginIndex:int;
		public function get selectionBeginIndex():int;
		public function set selectionBeginIndex(value:int):void;
		private var _selectionEndIndex:int;
		public function get selectionEndIndex():int;
		public function set selectionEndIndex(value:int):void;
		private var _text:String;
		private var textChanged:Boolean;
		public function get text():String;
		public function set text(value:String):void;
		protected var textField:IUITextField;
		private var _textHeight:Number;
		public function get textHeight():Number;
		private var _textWidth:Number;
		public function get textWidth():Number;
		override protected function createChildren():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function setFocus():void;
		override protected function isOurFocus(target:DisplayObject):Boolean;
		override public function drawFocus(isFocused:Boolean):void;
		override public function styleChanged(styleProp:String):void;
		mx_internal function createTextField(childIndex:int):void;
		mx_internal function removeTextField():void;
		protected function createBorder():void;
		public function getLineMetrics(lineIndex:int):TextLineMetrics;
		public function setSelection(beginIndex:int,endIndex:int):void;
		private function textFieldChanged(styleChangeOnly:Boolean,dispatchValueCommitEvent:Boolean):void;
		mx_internal function getTextField():IUITextField;
		override protected function focusInHandler(event:FocusEvent):void;
		override protected function focusOutHandler(event:FocusEvent):void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		private function textField_changeHandler(event:Event):void;
		private function textField_textInputHandler(event:TextEvent):void;
		private function textField_scrollHandler(event:Event):void;
		private function textField_textFieldStyleChangeHandler(event:Event):void;
		private function textField_textFormatChangeHandler(event:Event):void;
		private function textField_textModifiedHandler(event:Event):void;
	}
}
