package mx.controls.fileSystemClasses {
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.filesystem.File;
	import flash.system.Capabilities;
	import flash.ui.Keyboard;
	import mx.collections.ArrayCollection;
	import mx.controls.FileSystemEnumerationMode;
	import mx.controls.dataGridClasses.DataGridColumn;
	import mx.core.mx_internal;
	import mx.events.FileEvent;
	import mx.events.FlexEvent;
	import mx.events.ListEvent;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.utils.DirectoryEnumeration;
	public class FileSystemControlHelper {
		include "../../core/Version.as";
		public static var COMPUTER:File;
		private static function initClass():void;
		private static function fileSystemIsCaseInsensitive():Boolean;
		public function FileSystemControlHelper(owner:Object,hierarchical:Boolean);
		mx_internal var owner:Object;
		mx_internal var hierarchical:Boolean;
		mx_internal var resourceManager:IResourceManager;
		public function get backHistory():Array;
		public function get canNavigateBack():Boolean;
		public function get canNavigateDown():Boolean;
		public function get canNavigateForward():Boolean;
		public function get canNavigateUp():Boolean;
		private var _directory:File;
		private var directoryChanged:Boolean;
		public function get directory():File;
		public function set directory(value:File):void;
		mx_internal var directoryEnumeration:DirectoryEnumeration;
		private var _enumerationMode:String;
		private var enumerationModeChanged:Boolean;
		public function get enumerationMode():String;
		public function set enumerationMode(value:String):void;
		private var _extensions:Array;
		private var extensionsChanged:Boolean;
		public function get extensions():Array;
		public function set extensions(value:Array):void;
		private var _filterFunction:Function;
		private var filterFunctionChanged:Boolean;
		public function get filterFunction():Function;
		public function set filterFunction(value:Function):void;
		public function get forwardHistory():Array;
		public var history:Array;
		public var historyIndex:int;
		private var _nativePathToIndexMap:Object;
		mx_internal function get nativePathToIndexMap():Object;
		private var _itemArray:Array;
		mx_internal function get itemArray():Array;
		private var _nameCompareFunction:Function;
		private var nameCompareFunctionChanged:Boolean;
		public function get nameCompareFunction():Function;
		public function set nameCompareFunction(value:Function):void;
		private var pendingOpenPaths:Array;
		public function get openPaths():Array;
		public function set openPaths(value:Array):void;
		public function get selectedPath():String;
		public function set selectedPath(value:String):void;
		private var pendingSelectedPaths:Array;
		public function get selectedPaths():Array;
		public function set selectedPaths(value:Array):void;
		private var _showExtensions:Boolean;
		public function get showExtensions():Boolean;
		public function set showExtensions(value:Boolean):void;
		private var _showHidden:Boolean;
		private var showHiddenChanged:Boolean;
		public function get showHidden():Boolean;
		public function set showHidden(value:Boolean):void;
		private var _showIcons:Boolean;
		public function get showIcons():Boolean;
		public function set showIcons(value:Boolean):void;
		public function commitProperties():void;
		mx_internal function fill():void;
		public function styleChanged(styleProp:String):void;
		mx_internal function setDirectory(value:File):void;
		mx_internal function setDataProvider(value:Array):void;
		public function itemToUID(data:Object):String;
		public function isComputer(f:File):Boolean;
		private function getRootDirectories():Array;
		public function fileIconFunction(item:File):Class;
		public function fileLabelFunction(item:File,column:DataGridColumn=null):String;
		public function findIndex(nativePath:String):int;
		public function findItem(nativePath:String):File;
		mx_internal function itemsChanged():void;
		private function rebuildEnumerationInfo():void;
		private function addItemToEnumerationInfo(index:int,item:File):void;
		private function enumerateItems(itemCallback:Function):int;
		private function enumerate(items:ArrayCollection,index:int,itemCallback:Function):int;
		public function navigateDown():void;
		public function navigateUp():void;
		public function navigateBack(index:int=0):void;
		public function navigateForward(index:int=0):void;
		private function navigateBy(n:int):void;
		public function navigateTo(directory:File):void;
		public function refresh():void;
		private function getOpenPaths():Array;
		private function getSelectedPaths():Array;
		private function getFirstVisiblePath():String;
		private function setOpenPaths(openPaths:Array):void;
		private function setSelectedPaths(selectedPaths:Array):void;
		private function setFirstVisiblePath(path:String):Boolean;
		public function clear():void;
		public function resetHistory(directory:File):void;
		private function pushHistory(directory:File):void;
		public function getParentChain(file:File):Array;
		mx_internal function dispatchDirectoryChangingEvent(newDirectory:File):Boolean;
		mx_internal function dispatchFileChooseEvent(file:File):void;
		private function getBackDirectory():File;
		private function getForwardDirectory():File;
		private function updateCompleteHandler(event:FlexEvent):void;
		public function itemDoubleClickHandler(event:ListEvent):void;
		public function handleKeyDown(event:KeyboardEvent):Boolean;
	}
}
