package mx.controls.listClasses {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.DataEvent;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	import flash.utils.Dictionary;
	import flash.utils.clearInterval;
	import flash.utils.getTimer;
	import flash.utils.setInterval;
	import mx.collections.ArrayCollection;
	import mx.collections.CursorBookmark;
	import mx.collections.ICollectionView;
	import mx.collections.IList;
	import mx.collections.IViewCursor;
	import mx.collections.ItemResponder;
	import mx.collections.ItemWrapper;
	import mx.collections.ListCollectionView;
	import mx.collections.ModifiedCollectionView;
	import mx.collections.XMLListCollection;
	import mx.collections.errors.CursorError;
	import mx.collections.errors.ItemPendingError;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.core.DragSource;
	import mx.core.EdgeMetrics;
	import mx.core.EventPriority;
	import mx.core.FlexShape;
	import mx.core.FlexSprite;
	import mx.core.FlexVersion;
	import mx.core.IDataRenderer;
	import mx.core.IFactory;
	import mx.core.IFlexDisplayObject;
	import mx.core.IInvalidating;
	import mx.core.IRawChildrenContainer;
	import mx.core.IUIComponent;
	import mx.core.IUID;
	import mx.core.IUITextField;
	import mx.core.ScrollControlBase;
	import mx.core.ScrollPolicy;
	import mx.core.SpriteAsset;
	import mx.core.UITextField;
	import mx.core.mx_internal;
	import mx.effects.IEffect;
	import mx.effects.IEffectInstance;
	import mx.effects.IEffectTargetHost;
	import mx.effects.Tween;
	import mx.events.CollectionEvent;
	import mx.events.CollectionEventKind;
	import mx.events.DragEvent;
	import mx.events.EffectEvent;
	import mx.events.FlexEvent;
	import mx.events.ListEvent;
	import mx.events.SandboxMouseEvent;
	import mx.events.PropertyChangeEvent;
	import mx.events.ScrollEvent;
	import mx.events.ScrollEventDetail;
	import mx.events.ScrollEventDirection;
	import mx.events.TweenEvent;
	import mx.managers.DragManager;
	import mx.managers.IFocusManagerComponent;
	import mx.managers.ISystemManager;
	import mx.skins.halo.ListDropIndicator;
	import mx.styles.StyleManager;
	import mx.utils.ObjectUtil;
	import mx.utils.UIDUtil;
	import mx.events.MoveEvent;
	import mx.styles.StyleProxy;
	public class ListBase extends ScrollControlBase implements IDataRenderer {
		private var IS_ITEM_STYLE:Object;
		static const DRAG_THRESHOLD:int = 4;
		static var createAccessibilityImplementation:Function;
		protected var collection:ICollectionView;
		protected var iterator:IViewCursor;
		protected var iteratorValid:Boolean;
		protected var lastSeekPending:ListBaseSeekPending;
		protected var listContent:ListBaseContentHolder;
		private static var _listContentStyleFilters:Object;
		protected var selectionLayer:Sprite;
		protected var rowMap:Object;
		protected var factoryMap:Dictionary;
		protected var freeItemRenderers:Array;
		protected var freeItemRenderersByFactory:Dictionary;
		protected var reservedItemRenderers:Object;
		protected var unconstrainedRenderers:Dictionary;
		protected var dataItemWrappersByRenderer:Dictionary;
		protected var runDataEffectNextUpdate:Boolean;
		protected var runningDataEffect:Boolean;
		protected var cachedItemsChangeEffect:IEffect;
		protected var modifiedCollectionView:ModifiedCollectionView;
		protected var actualCollection:ICollectionView;
		protected var offscreenExtraRows:int;
		protected var offscreenExtraRowsTop:int;
		protected var offscreenExtraRowsBottom:int;
		protected var offscreenExtraColumns:int;
		protected var offscreenExtraColumnsLeft:int;
		protected var offscreenExtraColumnsRight:int;
		protected var actualIterator:IViewCursor;
		local var allowRendererStealingDuringLayout:Boolean;
		protected var highlightUID:String;
		protected var highlightItemRenderer:IListItemRenderer;
		protected var highlightIndicator:Sprite;
		protected var caretUID:String;
		protected var caretItemRenderer:IListItemRenderer;
		protected var caretIndicator:Sprite;
		protected var selectedData:Object;
		protected var selectionIndicators:Object;
		protected var selectionTweens:Object;
		protected var caretBookmark:CursorBookmark;
		protected var anchorBookmark:CursorBookmark;
		protected var showCaret:Boolean;
		protected var lastDropIndex:int;
		protected var itemsNeedMeasurement:Boolean;
		protected var itemsSizeChanged:Boolean;
		protected var rendererChanged:Boolean;
		protected var dataEffectCompleted:Boolean;
		protected var wordWrapChanged:Boolean;
		protected var keySelectionPending:Boolean;
		local var cachedPaddingTop:Number;
		local var cachedPaddingBottom:Number;
		local var cachedVerticalAlign:String;
		private var oldUnscaledWidth:Number;
		private var oldUnscaledHeight:Number;
		private var horizontalScrollPositionPending:Number;
		private var verticalScrollPositionPending:Number;
		private var mouseDownPoint:Point;
		private var bSortItemPending:Boolean;
		private var bShiftKey:Boolean;
		private var bCtrlKey:Boolean;
		private var lastKey:uint;
		private var bSelectItem:Boolean;
		private var approximate:Boolean;
		local var bColumnScrolling:Boolean;
		local var listType:String;
		local var bSelectOnRelease:Boolean;
		private var mouseDownItem:IListItemRenderer;
		local var bSelectionChanged:Boolean;
		local var bSelectedIndexChanged:Boolean;
		private var bSelectedItemChanged:Boolean;
		private var bSelectedItemsChanged:Boolean;
		private var bSelectedIndicesChanged:Boolean;
		private var cachedPaddingTopInvalid:Boolean;
		private var cachedPaddingBottomInvalid:Boolean;
		private var cachedVerticalAlignInvalid:Boolean;
		private var firstSelectionData:ListBaseSelectionData;
		private var lastSelectionData:ListBaseSelectionData;
		local var lastHighlightItemRenderer:IListItemRenderer;
		local var lastHighlightItemRendererAtIndices:IListItemRenderer;
		private var lastHighlightItemIndices:Point;
		local var dragScrollingInterval:int;
		private var itemMaskFreeList:Array;
		private var trackedRenderers:Array;
		private var rendererTrackingSuspended:Boolean;
		local var isPressed:Boolean;
		local var collectionIterator:IViewCursor;
		local var dropIndicator:IFlexDisplayObject;
		local var lastDragEvent:DragEvent;
		public var allowDragSelection:Boolean;
		private var _allowMultipleSelection:Boolean;
		protected var anchorIndex:int;
		protected var caretIndex:int;
		private var _columnCount:int;
		private var columnCountChanged:Boolean;
		private var _columnWidth:Number;
		private var columnWidthChanged:Boolean;
		private var _data:Object;
		private var _dataTipField:String;
		private var _dataTipFunction:Function;
		protected var defaultColumnCount:int;
		protected var defaultRowCount:int;
		private var _dragEnabled:Boolean;
		private var _dragMoveEnabled:Boolean;
		private var _dropEnabled:Boolean;
		protected var explicitColumnCount:int;
		protected var explicitColumnWidth:Number;
		protected var explicitRowCount:int;
		protected var explicitRowHeight:Number;
		private var _iconField:String;
		private var _iconFunction:Function;
		private var _itemRenderer:IFactory;
		private var _labelField:String;
		private var _labelFunction:Function;
		private var _listData:BaseListData;
		public var menuSelectionMode:Boolean;
		private var _offscreenExtraRowsOrColumns:int;
		protected var offscreenExtraRowsOrColumnsChanged:Boolean;
		private var _nullItemRenderer:IFactory;
		private var _rowCount:int;
		private var rowCountChanged:Boolean;
		private var _rowHeight:Number;
		private var rowHeightChanged:Boolean;
		private var _selectable:Boolean;
		local var _selectedIndex:int;
		private var _selectedIndices:Array;
		private var _selectedItem:Object;
		private var _selectedItems:Array;
		private var _showDataTips:Boolean;
		private var _variableRowHeight:Boolean;
		private var _wordWrap:Boolean;
		protected function get visibleData():Object;
		protected function get listContentStyleFilters():Object;
		protected function get listItems():Array;
		protected function get rowInfo():Array;
		function get rendererArray():Array;
		public function get baselinePosition():Number;
		public function set enabled(value:Boolean):void;
		public function set showInAutomationHierarchy(value:Boolean):void;
		public function set horizontalScrollPolicy(value:String):void;
		public function get horizontalScrollPosition():Number;
		public function set horizontalScrollPosition(value:Number):void;
		function set $horizontalScrollPosition(value:Number):void;
		public function set verticalScrollPolicy(value:String):void;
		public function get verticalScrollPosition():Number;
		public function set verticalScrollPosition(value:Number):void;
		function set $verticalScrollPosition(value:Number):void;
		public function get allowMultipleSelection():Boolean;
		public function set allowMultipleSelection(value:Boolean):void;
		public function get columnCount():int;
		public function set columnCount(value:int):void;
		public function get columnWidth():Number;
		public function set columnWidth(value:Number):void;
		public function get data():Object;
		public function set data(value:Object):void;
		public function get dataProvider():Object;
		public function set dataProvider(value:Object):void;
		public function get dataTipField():String;
		public function set dataTipField(value:String):void;
		public function get dataTipFunction():Function;
		public function set dataTipFunction(value:Function):void;
		public function get dragEnabled():Boolean;
		public function set dragEnabled(value:Boolean):void;
		protected function get dragImage():IUIComponent;
		protected function get dragImageOffsets():Point;
		public function get dragMoveEnabled():Boolean;
		public function set dragMoveEnabled(value:Boolean):void;
		public function get dropEnabled():Boolean;
		public function set dropEnabled(value:Boolean):void;
		public function get iconField():String;
		public function set iconField(value:String):void;
		public function get iconFunction():Function;
		public function set iconFunction(value:Function):void;
		public function get itemRenderer():IFactory;
		public function set itemRenderer(value:IFactory):void;
		public function get labelField():String;
		public function set labelField(value:String):void;
		public function get labelFunction():Function;
		public function set labelFunction(value:Function):void;
		public function get listData():BaseListData;
		public function set listData(value:BaseListData):void;
		public function get offscreenExtraRowsOrColumns():int;
		public function set offscreenExtraRowsOrColumns(value:int):void;
		public function get nullItemRenderer():IFactory;
		public function set nullItemRenderer(value:IFactory):void;
		public function get rowCount():int;
		public function set rowCount(value:int):void;
		public function get rowHeight():Number;
		public function set rowHeight(value:Number):void;
		public function get selectable():Boolean;
		public function set selectable(value:Boolean):void;
		public function get selectedIndex():int;
		public function set selectedIndex(value:int):void;
		public function get selectedIndices():Array;
		public function set selectedIndices(indices:Array):void;
		public function get selectedItem():Object;
		public function set selectedItem(data:Object):void;
		public function get selectedItems():Array;
		public function set selectedItems(items:Array):void;
		public function get showDataTips():Boolean;
		public function set showDataTips(value:Boolean):void;
		public function get value():Object;
		public function get variableRowHeight():Boolean;
		public function set variableRowHeight(value:Boolean):void;
		public function get wordWrap():Boolean;
		public function set wordWrap(value:Boolean):void;
		protected function set allowItemSizeChangeNotification(value:Boolean):void;
		public function ListBase();
		private function makeRowsAndColumnsWithExtraRows(unscaledWidth:Number, unscaledHeight:Number):void;
		private function makeRowsAndColumnsWithExtraColumns(unscaledWidth:Number, unscaledHeight:Number):void;
		function setColumnCount(value:int):void;
		function setColumnWidth(value:Number):void;
		protected function setRowCount(v:int):void;
		protected function setRowHeight(v:Number):void;
		protected function initializeAccessibility():void;
		protected function createChildren():void;
		protected function commitProperties():void;
		protected function measure():void;
		public function validateDisplayList():void;
		protected function initiateDataChangeEffect(unscaledWidth:Number, unscaledHeight:Number):void;
		private function initiateSelectionTracking(renderers:Array):void;
		private function terminateSelectionTracking():void;
		public function removeDataEffectItem(item:Object):void;
		public function addDataEffectItem(item:Object):void;
		public function unconstrainRenderer(item:Object):void;
		public function getRendererSemanticValue(target:Object, semanticProperty:String):Object;
		protected function isRendererUnconstrained(item:Object):Boolean;
		protected function finishDataChangeEffect(event:EffectEvent):void;
		private function cleanupAfterDataChangeEffect():void;
		protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void;
		protected function adjustListContent(unscaledWidth:Number = -1, unscaledHeight:Number = -1):void;
		private function adjustScrollPosition():void;
		function adjustOffscreenRowsAndColumns():void;
		protected function purgeItemRenderers():void;
		private function partialPurgeItemRenderers():void;
		private function reduceRows(rowIndex:int):void;
		private function makeAdditionalRows(rowIndex:int):void;
		private function adjustSelectionSettings(collectionHasItems:Boolean):void;
		private function seekPositionIgnoreError(iterator:IViewCursor, cursorPos:CursorBookmark):void;
		private function seekNextSafely(iterator:IViewCursor, pos:int):Boolean;
		private function seekPreviousSafely(iterator:IViewCursor, pos:int):Boolean;
		protected function seekPositionSafely(index:int):Boolean;
		public function styleChanged(styleProp:String):void;
		public function measureWidthOfItems(index:int = -1, count:int = 0):Number;
		public function measureHeightOfItems(index:int = -1, count:int = 0):Number;
		public function itemToLabel(data:Object):String;
		public function itemToDataTip(data:Object):String;
		public function itemToIcon(data:Object):Class;
		protected function makeRowsAndColumns(left:Number, top:Number, right:Number, bottom:Number, firstColumn:int, firstRow:int, byCount:Boolean = false, rowsNeeded:uint = 0):Point;
		public function indicesToIndex(rowIndex:int, colIndex:int):int;
		protected function indexToRow(index:int):int;
		protected function indexToColumn(index:int):int;
		function indicesToItemRenderer(row:int, col:int):IListItemRenderer;
		protected function itemRendererToIndices(item:IListItemRenderer):Point;
		public function indexToItemRenderer(index:int):IListItemRenderer;
		public function itemRendererToIndex(itemRenderer:IListItemRenderer):int;
		protected function itemToUID(data:Object):String;
		protected function UIDToItemRenderer(uid:String):IListItemRenderer;
		public function itemToItemRenderer(item:Object):IListItemRenderer;
		public function isItemVisible(item:Object):Boolean;
		protected function mouseEventToItemRenderer(event:MouseEvent):IListItemRenderer;
		function mouseEventToItemRendererOrEditor(event:MouseEvent):IListItemRenderer;
		function hasOnlyTextRenderers():Boolean;
		public function itemRendererContains(renderer:IListItemRenderer, object:DisplayObject):Boolean;
		protected function addToFreeItemRenderers(item:IListItemRenderer):void;
		protected function getReservedOrFreeItemRenderer(data:Object):IListItemRenderer;
		public function getItemRendererFactory(data:Object):IFactory;
		protected function drawRowBackgrounds():void;
		protected function drawItem(item:IListItemRenderer, selected:Boolean = false, highlighted:Boolean = false, caret:Boolean = false, transition:Boolean = false):void;
		protected function drawHighlightIndicator(indicator:Sprite, x:Number, y:Number, width:Number, height:Number, color:uint, itemRenderer:IListItemRenderer):void;
		protected function clearHighlightIndicator(indicator:Sprite, itemRenderer:IListItemRenderer):void;
		protected function drawSelectionIndicator(indicator:Sprite, x:Number, y:Number, width:Number, height:Number, color:uint, itemRenderer:IListItemRenderer):void;
		protected function drawCaretIndicator(indicator:Sprite, x:Number, y:Number, width:Number, height:Number, color:uint, itemRenderer:IListItemRenderer):void;
		protected function clearCaretIndicator(indicator:Sprite, itemRenderer:IListItemRenderer):void;
		protected function clearIndicators():void;
		protected function removeIndicators(uid:String):void;
		function clearHighlight(item:IListItemRenderer):void;
		public function invalidateList():void;
		protected function updateList():void;
		protected function clearVisibleData():void;
		protected function reKeyVisibleData():void;
		function addClipMask(layoutChanged:Boolean):void;
		function createItemMask(x:Number, y:Number, width:Number, height:Number):DisplayObject;
		function removeClipMask():void;
		public function isItemHighlighted(data:Object):Boolean;
		public function isItemSelected(data:Object):Boolean;
		public function isItemSelectable(data:Object):Boolean;
		private function calculateSelectedIndexAndItem():void;
		protected function selectItem(item:IListItemRenderer, shiftKey:Boolean, ctrlKey:Boolean, transition:Boolean = true):Boolean;
		private function shiftSelectionLoop(incr:Boolean, index:int, stopData:Object, transition:Boolean, placeHolder:CursorBookmark):void;
		protected function clearSelected(transition:Boolean = false):void;
		protected function moveSelectionHorizontally(code:uint, shiftKey:Boolean, ctrlKey:Boolean):void;
		protected function moveSelectionVertically(code:uint, shiftKey:Boolean, ctrlKey:Boolean):void;
		protected function finishKeySelection():void;
		function commitSelectedIndex(value:int):void;
		function commitSelectedIndices(indices:Array):void;
		private function setSelectionIndicesLoop(index:int, indices:Array, firstTime:Boolean = false):void;
		private function commitSelectedItem(data:Object, clearFirst:Boolean = true):void;
		private function commitSelectedItems(items:Array):void;
		private function setSelectionDataLoop(items:Array, index:int, useFind:Boolean = true):void;
		private function clearSelectionData():void;
		private function insertSelectionDataBefore(uid:String, selectionData:ListBaseSelectionData, nextSelectionData:ListBaseSelectionData):void;
		private function insertSelectionDataAfter(uid:String, selectionData:ListBaseSelectionData, prevSelectionData:ListBaseSelectionData):void;
		private function removeSelectionData(uid:String):void;
		protected function applySelectionEffect(indicator:Sprite, uid:String, itemRenderer:IListItemRenderer):void;
		private function onSelectionTweenUpdate(value:Number):void;
		protected function copySelectedItems(useDataField:Boolean = true):Array;
		protected function scrollPositionToIndex(horizontalScrollPosition:int, verticalScrollPosition:int):int;
		public function scrollToIndex(index:int):Boolean;
		protected function scrollVertically(pos:int, deltaPos:int, scrollUp:Boolean):void;
		protected function destroyRow(i:int, numCols:int):void;
		protected function moveRowVertically(i:int, numCols:int, moveBlockDistance:Number):void;
		protected function shiftRow(oldIndex:int, newIndex:int, numCols:int, shiftItems:Boolean):void;
		protected function moveIndicatorsVertically(uid:String, moveBlockDistance:Number):void;
		protected function moveIndicatorsHorizontally(uid:String, moveBlockDistance:Number):void;
		protected function sumRowHeights(startRowIdx:int, endRowIdx:int):Number;
		protected function truncateRowArrays(numRows:int):void;
		protected function addToRowArrays():void;
		protected function restoreRowArrays(modDeltaPos:int):void;
		protected function removeFromRowArrays(i:int):void;
		protected function scrollHorizontally(pos:int, deltaPos:int, scrollUp:Boolean):void;
		public function createItemRenderer(data:Object):IListItemRenderer;
		protected function configureScrollBars():void;
		protected function dragScroll():void;
		function resetDragScrolling():void;
		protected function addDragData(ds:Object):void;
		public function calculateDropIndex(event:DragEvent = null):int;
		protected function calculateDropIndicatorY(rowCount:Number, rowNum:int):Number;
		public function showDropFeedback(event:DragEvent):void;
		public function hideDropFeedback(event:DragEvent):void;
		protected function seekPendingFailureHandler(data:Object, info:ListBaseSeekPending):void;
		protected function seekPendingResultHandler(data:Object, info:ListBaseSeekPending):void;
		private function findPendingFailureHandler(data:Object, info:ListBaseFindPending):void;
		private function findPendingResultHandler(data:Object, info:ListBaseFindPending):void;
		private function selectionPendingFailureHandler(data:Object, info:ListBaseSelectionPending):void;
		private function selectionPendingResultHandler(data:Object, info:ListBaseSelectionPending):void;
		private function selectionDataPendingFailureHandler(data:Object, info:ListBaseSelectionDataPending):void;
		function selectionDataPendingResultHandler(data:Object, info:ListBaseSelectionDataPending):void;
		private function selectionIndicesPendingFailureHandler(data:Object, info:ListBaseSelectionDataPending):void;
		private function selectionIndicesPendingResultHandler(data:Object, info:ListBaseSelectionDataPending):void;
		protected function findKey(eventCode:int):Boolean;
		public function findString(str:String):Boolean;
		private function findStringLoop(str:String, cursorPos:CursorBookmark, i:int, stopIndex:int):Boolean;
		private function adjustAfterSort():void;
		protected function keyDownHandler(event:KeyboardEvent):void;
		protected function mouseWheelHandler(event:MouseEvent):void;
		protected function collectionChangeHandler(event:Event):void;
		function reconstructDataFromListItems():Array;
		protected function prepareDataEffect(ce:CollectionEvent):void;
		protected function adjustAfterAdd(items:Array, location:int):Boolean;
		protected function adjustAfterRemove(items:Array, location:int, emitEvent:Boolean):Boolean;
		function setBookmarkPendingFailureHandler(data:Object, info:Object):void;
		function setBookmarkPendingResultHandler(data:Object, info:Object):void;
		protected function mouseOverHandler(event:MouseEvent):void;
		protected function mouseOutHandler(event:MouseEvent):void;
		protected function mouseMoveHandler(event:MouseEvent):void;
		protected function mouseDownHandler(event:MouseEvent):void;
		private function mouseIsUp():void;
		private function mouseLeaveHandler(event:Event):void;
		protected function mouseUpHandler(event:MouseEvent):void;
		protected function mouseClickHandler(event:MouseEvent):void;
		protected function mouseDoubleClickHandler(event:MouseEvent):void;
		protected function dragStartHandler(event:DragEvent):void;
		protected function dragEnterHandler(event:DragEvent):void;
		protected function dragOverHandler(event:DragEvent):void;
		protected function dragExitHandler(event:DragEvent):void;
		protected function dragDropHandler(event:DragEvent):void;
		protected function copyItemWithUID(item:Object):Object;
		protected function dragCompleteHandler(event:DragEvent):void;
		function selectionTween_updateHandler(event:TweenEvent):void;
		function selectionTween_endHandler(event:TweenEvent):void;
		private function rendererMoveHandler(event:MoveEvent):void;
		function getListVisibleData():Object;
		function getItemUID(data:Object):String;
		function getItemRendererForMouseEvent(event:MouseEvent):IListItemRenderer;
		function getListContentHolder():ListBaseContentHolder;
		function getRowInfo():Array;
		function convertIndexToRow(index:int):int;
		function convertIndexToColumn(index:int):int;
		function getCaretIndex():int;
		function getIterator():IViewCursor;
	}
}
