package mx.controls.sliderClasses {
	import flash.display.DisplayObject;
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.getTimer;
	import mx.core.FlexVersion;
	import mx.core.IFlexDisplayObject;
	import mx.core.mx_internal;
	import mx.core.UIComponent;
	import mx.effects.Tween;
	import mx.events.FlexEvent;
	import mx.events.SliderEvent;
	import mx.events.SliderEventClickTarget;
	import mx.formatters.NumberFormatter;
	import mx.managers.ISystemManager;
	import mx.managers.SystemManager;
	import mx.styles.ISimpleStyleClient;
	import mx.styles.StyleProxy;
	include "../../styles/metadata/FillStyles.as";
	public class Slider extends UIComponent {
		include "../../core/Version.as";
		mx_internal static var createAccessibilityImplementation:Function;
		public function Slider();
		private var track:IFlexDisplayObject;
		private var thumbs:UIComponent;
		private var thumbsChanged:Boolean;
		private var ticks:UIComponent;
		private var ticksChanged:Boolean;
		private var labelObjects:UIComponent;
		private var highlightTrack:IFlexDisplayObject;
		mx_internal var innerSlider:UIComponent;
		private var trackHitArea:UIComponent;
		mx_internal var dataTip:SliderDataTip;
		private var trackHighlightChanged:Boolean;
		private var initValues:Boolean;
		private var dataFormatter:NumberFormatter;
		private var interactionClickTarget:String;
		private var labelStyleChanged:Boolean;
		mx_internal var keyInteraction:Boolean;
		override public function get baselinePosition():Number;
		private var _enabled:Boolean;
		private var enabledChanged:Boolean;
		override public function get enabled():Boolean;
		override public function set enabled(value:Boolean):void;
		private var _tabIndex:Number;
		private var tabIndexChanged:Boolean;
		override public function set tabIndex(value:int):void;
		public var allowThumbOverlap:Boolean;
		public var allowTrackClick:Boolean;
		private var _dataTipFormatFunction:Function;
		public function get dataTipFormatFunction():Function;
		public function set dataTipFormatFunction(value:Function):void;
		private var _direction:String;
		private var directionChanged:Boolean;
		public function get direction():String;
		public function set direction(value:String):void;
		private var _labels:Array;
		private var labelsChanged:Boolean;
		public function get labels():Array;
		public function set labels(value:Array):void;
		public var liveDragging:Boolean;
		private var _maximum:Number;
		public function get maximum():Number;
		public function set maximum(value:Number):void;
		private var _minimum:Number;
		private var minimumSet:Boolean;
		public function get minimum():Number;
		public function set minimum(value:Number):void;
		public var showDataTip:Boolean;
		private var _thumbClass:Class;
		public function get sliderThumbClass():Class;
		public function set sliderThumbClass(value:Class):void;
		private var _sliderDataTipClass:Class;
		public function get sliderDataTipClass():Class;
		public function set sliderDataTipClass(value:Class):void;
		private var _snapInterval:Number;
		private var snapIntervalPrecision:int;
		private var snapIntervalChanged:Boolean;
		public function get snapInterval():Number;
		public function set snapInterval(value:Number):void;
		private var _thumbCount:int;
		public function get thumbCount():int;
		public function set thumbCount(value:int):void;
		protected function get thumbStyleFilters():Object;
		private var _tickInterval:Number;
		public function get tickInterval():Number;
		public function set tickInterval(value:Number):void;
		private var _tickValues:Array;
		public function get tickValues():Array;
		public function set tickValues(value:Array):void;
		public function get value():Number;
		public function set value(val:Number):void;
		private var _values:Array;
		private var valuesChanged:Boolean;
		public function get values():Array;
		public function set values(value:Array):void;
		override protected function initializeAccessibility():void;
		override protected function createChildren():void;
		override public function styleChanged(styleProp:String):void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		private function createBackgroundTrack():void;
		private function createHighlightTrack():void;
		private function createThumbs():void;
		private function createLabels():void;
		private function createTicks():void;
		private function getComponentBounds():Object;
		private function layoutTicks():void;
		private function layoutLabels():void;
		mx_internal function drawTrackHighlight():void;
		mx_internal function onThumbPress(thumb:Object):void;
		mx_internal function onThumbRelease(thumb:Object):void;
		mx_internal function onThumbMove(thumb:Object):void;
		private function positionDataTip(thumb:Object):void;
		private function destroyDataTip():void;
		mx_internal function getXFromValue(v:Number):Number;
		mx_internal function getXBounds(selectedThumbIndex:int):Object;
		private function setPosFromValue():void;
		mx_internal function getValueFromX(xPos:Number):Number;
		private function setValueFromPos(thumbIndex:int):void;
		mx_internal function getSnapValue(value:Number,thumb:SliderThumb=null):Number;
		mx_internal function getSnapIntervalWidth():Number;
		mx_internal function updateThumbValue(thumbIndex:int):void;
		public function getThumbAt(index:int):SliderThumb;
		public function setThumbValueAt(index:int,value:Number):void;
		private function setValueAt(value:Number,index:int,isProgrammatic:Boolean=false):void;
		mx_internal function registerMouseMove(listener:Function):void;
		mx_internal function unRegisterMouseMove(listener:Function):void;
		private function track_mouseDownHandler(event:MouseEvent):void;
		private function thumb_focusInHandler(event:FocusEvent):void;
		private function thumb_focusOutHandler(event:FocusEvent):void;
		mx_internal function getTrackHitArea():UIComponent;
	}
}
