package mx.core {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextLineMetrics;
	import flash.utils.getQualifiedClassName;
	import mx.automation.IAutomationObject;
	import mx.core.FlexVersion;
	import mx.managers.ISystemManager;
	import mx.managers.IToolTipManagerClient;
	import mx.managers.SystemManager;
	import mx.managers.ToolTipManager;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.styles.ISimpleStyleClient;
	import mx.styles.IStyleClient;
	import mx.styles.StyleManager;
	import mx.styles.StyleProtoChain;
	import mx.utils.StringUtil;
	include "../styles/metadata/LeadingStyle.as";
	include "../styles/metadata/PaddingStyles.as";
	include "../styles/metadata/TextStyles.as";
	public class UITextField extends FlexTextField implements IAutomationObject, IIMESupport, IFlexModule, IInvalidating, ISimpleStyleClient, IToolTipManagerClient, IUITextField {
		include "../core/Version.as";
		mx_internal static const TEXT_WIDTH_PADDING:int=5;
		mx_internal static const TEXT_HEIGHT_PADDING:int=4;
		private static var truncationIndicatorResource:String;
		mx_internal static var debuggingBorders:Boolean;
		private static var _embeddedFontRegistry:IEmbeddedFontRegistry;
		private static function get embeddedFontRegistry():IEmbeddedFontRegistry;
		public function UITextField();
		private var cachedTextFormat:TextFormat;
		private var cachedEmbeddedFont:EmbeddedFont;
		private var invalidateDisplayListFlag:Boolean;
		mx_internal var styleChangedFlag:Boolean;
		private var explicitHTMLText:String;
		mx_internal var explicitColor:uint;
		private var resourceManager:IResourceManager;
		private var untruncatedText:String;
		override public function set htmlText(value:String):void;
		mx_internal var _parent:DisplayObjectContainer;
		override public function get parent():DisplayObjectContainer;
		override public function set text(value:String):void;
		private var _automationDelegate:IAutomationObject;
		public function get automationDelegate():Object;
		public function set automationDelegate(value:Object):void;
		private var _automationName:String;
		public function get automationName():String;
		public function set automationName(value:String):void;
		public function get automationValue():Array;
		public function get baselinePosition():Number;
		public function get className():String;
		private var _document:Object;
		public function get document():Object;
		public function set document(value:Object):void;
		private var _enabled:Boolean;
		public function get enabled():Boolean;
		public function set enabled(value:Boolean):void;
		private var _explicitHeight:Number;
		public function get explicitHeight():Number;
		public function set explicitHeight(value:Number):void;
		public function get explicitMaxHeight():Number;
		public function get explicitMaxWidth():Number;
		public function get explicitMinHeight():Number;
		public function get explicitMinWidth():Number;
		private var _explicitWidth:Number;
		public function get explicitWidth():Number;
		public function set explicitWidth(value:Number):void;
		public function get focusPane():Sprite;
		public function set focusPane(value:Sprite):void;
		private var _ignorePadding:Boolean;
		public function get ignorePadding():Boolean;
		public function set ignorePadding(value:Boolean):void;
		private var _imeMode:String;
		public function get imeMode():String;
		public function set imeMode(value:String):void;
		private var _includeInLayout:Boolean;
		public function get includeInLayout():Boolean;
		public function set includeInLayout(value:Boolean):void;
		private var _inheritingStyles:Object;
		public function get inheritingStyles():Object;
		public function set inheritingStyles(value:Object):void;
		private var _initialized:Boolean;
		public function get initialized():Boolean;
		public function set initialized(value:Boolean):void;
		private function get isHTML():Boolean;
		public function get isPopUp():Boolean;
		public function set isPopUp(value:Boolean):void;
		public function get maxHeight():Number;
		public function get maxWidth():Number;
		public function get measuredHeight():Number;
		public function get measuredMinHeight():Number;
		public function set measuredMinHeight(value:Number):void;
		public function get measuredMinWidth():Number;
		public function set measuredMinWidth(value:Number):void;
		public function get measuredWidth():Number;
		public function get minHeight():Number;
		public function get minWidth():Number;
		private var _moduleFactory:IFlexModuleFactory;
		public function get moduleFactory():IFlexModuleFactory;
		public function set moduleFactory(factory:IFlexModuleFactory):void;
		private var _nestLevel:int;
		public function get nestLevel():int;
		public function set nestLevel(value:int):void;
		private var _nonInheritingStyles:Object;
		public function get nonInheritingStyles():Object;
		public function set nonInheritingStyles(value:Object):void;
		public function get percentHeight():Number;
		public function set percentHeight(value:Number):void;
		public function get percentWidth():Number;
		public function set percentWidth(value:Number):void;
		private var _processedDescriptors:Boolean;
		public function get processedDescriptors():Boolean;
		public function set processedDescriptors(value:Boolean):void;
		private var _styleName:Object;
		public function get styleName():Object;
		public function set styleName(value:Object):void;
		public function get systemManager():ISystemManager;
		public function set systemManager(value:ISystemManager):void;
		public function get nonZeroTextHeight():Number;
		mx_internal var _toolTip:String;
		public function get toolTip():String;
		public function set toolTip(value:String):void;
		public function get tweeningProperties():Array;
		public function set tweeningProperties(value:Array):void;
		private var _updateCompletePendingFlag:Boolean;
		public function get updateCompletePendingFlag():Boolean;
		public function set updateCompletePendingFlag(value:Boolean):void;
		override public function setTextFormat(format:TextFormat,beginIndex:int=-1,endIndex:int=-1):void;
		override public function insertXMLText(beginIndex:int,endIndex:int,richText:String,pasting:Boolean=false):void;
		override public function replaceText(beginIndex:int,endIndex:int,newText:String):void;
		public function initialize():void;
		public function getExplicitOrMeasuredWidth():Number;
		public function getExplicitOrMeasuredHeight():Number;
		public function setVisible(visible:Boolean,noEvent:Boolean=false):void;
		public function setFocus():void;
		public function getUITextFormat():UITextFormat;
		public function move(x:Number,y:Number):void;
		public function setActualSize(w:Number,h:Number):void;
		public function getStyle(styleProp:String):*;
		public function setStyle(styleProp:String,value:*):void;
		public function parentChanged(p:DisplayObjectContainer):void;
		public function styleChanged(styleProp:String):void;
		public function validateNow():void;
		public function getTextStyles():TextFormat;
		public function setColor(color:uint):void;
		public function invalidateSize():void;
		public function invalidateDisplayList():void;
		public function invalidateProperties():void;
		public function truncateToFit(truncationIndicator:String=null):Boolean;
		private function changeHandler(event:Event):void;
		private function textFieldStyleChangeHandler(event:Event):void;
		private function resourceManager_changeHandler(event:Event):void;
		public function owns(child:DisplayObject):Boolean;
		private var _owner:DisplayObjectContainer;
		public function get owner():DisplayObjectContainer;
		public function set owner(value:DisplayObjectContainer):void;
		private function creatingSystemManager():ISystemManager;
		private function getEmbeddedFont(fontName:String,bold:Boolean,italic:Boolean):EmbeddedFont;
		public function replayAutomatableEvent(event:Event):Boolean;
		public function createAutomationIDPart(child:IAutomationObject):Object;
		public function resolveAutomationIDPart(criteria:Object):Array;
		public function getAutomationChildAt(index:int):IAutomationObject;
		public function get numAutomationChildren():int;
		public function get showInAutomationHierarchy():Boolean;
		public function set showInAutomationHierarchy(value:Boolean):void;
		public function get automationTabularData():Object;
	}
}
