package mx.core {
	import flash.desktop.NativeApplication;
	import flash.display.DisplayObject;
	import flash.display.Graphics;
	import flash.display.NativeWindow;
	import flash.display.NativeWindowDisplayState;
	import flash.display.NativeWindowInitOptions;
	import flash.display.NativeWindowResize;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.NativeWindowBoundsEvent;
	import flash.events.NativeWindowDisplayStateEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.system.Capabilities;
	import mx.controls.Button;
	import mx.controls.FlexNativeMenu;
	import mx.core.windowClasses.StatusBar;
	import mx.core.windowClasses.TitleBar;
	import mx.events.AIREvent;
	import mx.events.FlexEvent;
	import mx.events.FlexNativeWindowBoundsEvent;
	import mx.managers.CursorManagerImpl;
	import mx.managers.FocusManager;
	import mx.managers.ICursorManager;
	import mx.managers.ISystemManager;
	import mx.managers.WindowedSystemManager;
	import mx.styles.CSSStyleDeclaration;
	import mx.styles.StyleManager;
	import mx.styles.StyleProxy;
	public class Window extends LayoutContainer implements IWindow {
		include "../core/Version.as";
		private static const HEADER_PADDING:Number=4;
		private static const MOUSE_SLACK:Number=5;
		private static const DEFAULT_WINDOW_HEIGHT:Number=100;
		private static const DEFAULT_WINDOW_WIDTH:Number=100;
		public static function getWindow(component:UIComponent):Window;
		public function Window();
		private var _nativeWindow:NativeWindow;
		private var _nativeWindowVisible:Boolean;
		private var maximized:Boolean;
		private var _cursorManager:ICursorManager;
		private var toMax:Boolean;
		private var appViewMetrics:EdgeMetrics;
		private var frameCounter:int;
		private var gripper:Button;
		private var gripperHit:Sprite;
		private var flagForOpen:Boolean;
		private var openActive:Boolean;
		mx_internal var titleBarBackground:IFlexDisplayObject;
		mx_internal var statusBarBackground:IFlexDisplayObject;
		private var oldX:Number;
		private var oldY:Number;
		private var prevX:Number;
		private var prevY:Number;
		private var resizeHandlerAdded:Boolean;
		private var resizeWidth:Boolean;
		private var resizeHeight:Boolean;
		override public function get height():Number;
		override public function set height(value:Number):void;
		private var _maxHeight:Number;
		private var maxHeightChanged:Boolean;
		override public function get maxHeight():Number;
		override public function set maxHeight(value:Number):void;
		private var _maxWidth:Number;
		private var maxWidthChanged:Boolean;
		override public function get maxWidth():Number;
		override public function set maxWidth(value:Number):void;
		private var _minHeight:Number;
		private var minHeightChanged:Boolean;
		override public function get minHeight():Number;
		override public function set minHeight(value:Number):void;
		private var _minWidth:Number;
		private var minWidthChanged:Boolean;
		override public function get minWidth():Number;
		override public function set minWidth(value:Number):void;
		override public function get visible():Boolean;
		override public function set visible(value:Boolean):void;
		override public function get width():Number;
		override public function set width(value:Number):void;
		override public function get viewMetrics():EdgeMetrics;
		private var _alwaysInFront:Boolean;
		public function get alwaysInFront():Boolean;
		public function set alwaysInFront(value:Boolean):void;
		private var _bounds:Rectangle;
		private var boundsChanged:Boolean;
		protected function get bounds():Rectangle;
		protected function set bounds(value:Rectangle):void;
		public function get closed():Boolean;
		public var controlBar:IUIComponent;
		private var _maximizable:Boolean;
		public function get maximizable():Boolean;
		public function set maximizable(value:Boolean):void;
		private var _menu:FlexNativeMenu;
		override public function get cursorManager():ICursorManager;
		private var menuChanged:Boolean;
		public function get menu():FlexNativeMenu;
		public function set menu(value:FlexNativeMenu):void;
		private var _minimizable:Boolean;
		public function get minimizable():Boolean;
		public function set minimizable(value:Boolean):void;
		public function get nativeWindow():NativeWindow;
		private var _resizable:Boolean;
		public function get resizable():Boolean;
		public function set resizable(value:Boolean):void;
		private var _showGripper:Boolean;
		private var showGripperChanged:Boolean;
		public function get showGripper():Boolean;
		public function set showGripper(value:Boolean):void;
		private var _showStatusBar:Boolean;
		private var showStatusBarChanged:Boolean;
		public function get showStatusBar():Boolean;
		public function set showStatusBar(value:Boolean):void;
		private var _showTitleBar:Boolean;
		private var showTitleBarChanged:Boolean;
		public function get showTitleBar():Boolean;
		public function set showTitleBar(value:Boolean):void;
		private var _status:String;
		private var statusChanged:Boolean;
		public function get status():String;
		public function set status(value:String):void;
		private var _statusBar:UIComponent;
		public function get statusBar():UIComponent;
		private var _statusBarFactory:IFactory;
		private var statusBarFactoryChanged:Boolean;
		public function get statusBarFactory():IFactory;
		public function set statusBarFactory(value:IFactory):void;
		private static var _statusBarStyleFilters:Object;
		protected function get statusBarStyleFilters():Object;
		private var _systemChrome:String;
		public function get systemChrome():String;
		public function set systemChrome(value:String):void;
		private var _title:String;
		private var titleChanged:Boolean;
		public function get title():String;
		public function set title(value:String):void;
		private var _titleBar:UIComponent;
		public function get titleBar():UIComponent;
		private var _titleBarFactory:IFactory;
		private var titleBarFactoryChanged:Boolean;
		public function get titleBarFactory():IFactory;
		public function set titleBarFactory(value:IFactory):void;
		private static var _titleBarStyleFilters:Object;
		protected function get titleBarStyleFilters():Object;
		private var _titleIcon:Class;
		private var titleIconChanged:Boolean;
		public function get titleIcon():Class;
		public function set titleIcon(value:Class):void;
		private var _transparent:Boolean;
		public function get transparent():Boolean;
		public function set transparent(value:Boolean):void;
		private var _type:String;
		public function get type():String;
		public function set type(value:String):void;
		override public function initialize():void;
		override protected function createChildren():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override public function validateDisplayList():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function styleChanged(styleProp:String):void;
		override public function move(x:Number,y:Number):void;
		override mx_internal function initThemeColor():Boolean;
		public function close():void;
		private function getHeaderHeight():Number;
		public function getStatusBarHeight():Number;
		private function initManagers(sm:ISystemManager):void;
		public function maximize():void;
		public function minimize():void;
		public function restore():void;
		public function activate():void;
		public function open(openWindowActive:Boolean=true):void;
		public function orderInBackOf(window:IWindow):Boolean;
		public function orderInFrontOf(window:IWindow):Boolean;
		public function orderToBack():Boolean;
		public function orderToFront():Boolean;
		private function chromeWidth():Number;
		private function chromeHeight():Number;
		private function startMove(event:MouseEvent):void;
		private function startResize(start:String):void;
		private function enterFrameHandler(e:Event):void;
		private function hideEffectEndHandler(event:Event):void;
		private function windowMinimizeHandler(event:Event):void;
		private function windowUnminimizeHandler(event:Event):void;
		private function window_moveHandler(event:NativeWindowBoundsEvent):void;
		private function window_displayStateChangeHandler(event:NativeWindowDisplayStateEvent):void;
		private function window_displayStateChangingHandler(event:NativeWindowDisplayStateEvent):void;
		private function windowMaximizeHandler(event:Event):void;
		private function windowUnmaximizeHandler(event:Event):void;
		protected function mouseDownHandler(event:MouseEvent):void;
		private function closeButton_clickHandler(event:Event):void;
		private function resizeHandler(event:Event):void;
		private function creationCompleteHandler(event:Event=null):void;
		private function preinitializeHandler(event:FlexEvent):void;
		private function mouseMoveHandler(event:MouseEvent):void;
		private function mouseUpHandler(event:MouseEvent):void;
		private function window_boundsHandler(event:NativeWindowBoundsEvent):void;
		private function window_closeEffectEndHandler(event:Event):void;
		private function window_closingHandler(event:Event):void;
		private function window_closeHandler(event:Event):void;
		private function window_resizeHandler(event:NativeWindowBoundsEvent):void;
		private function nativeApplication_activateHandler(event:Event):void;
		private function nativeApplication_deactivateHandler(event:Event):void;
		private function nativeWindow_activateHandler(event:Event):void;
		private function nativeWindow_deactivateHandler(event:Event):void;
		private function nativeApplication_networkChangeHandler(event:Event):void;
	}
}
