package mx.managers {
	import flash.display.DisplayObject;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IEventDispatcher;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.Timer;
	import mx.controls.ToolTip;
	import mx.core.ApplicationGlobals;
	import mx.core.IInvalidating;
	import mx.core.IToolTip;
	import mx.core.IUIComponent;
	import mx.core.mx_internal;
	import mx.effects.IAbstractEffect;
	import mx.effects.EffectManager;
	import mx.events.EffectEvent;
	import mx.events.ToolTipEvent;
	import mx.events.InterManagerRequest;
	import mx.managers.IToolTipManagerClient;
	import mx.styles.IStyleClient;
	import mx.validators.IValidatorListener;
	public class ToolTipManagerImpl extends EventDispatcher implements IToolTipManager2 {
		include "../core/Version.as";
		private static var instance:IToolTipManager2;
		public static function getInstance():IToolTipManager2;
		public function ToolTipManagerImpl();
		private var systemManager:ISystemManager;
		private var sandboxRoot:IEventDispatcher;
		mx_internal var initialized:Boolean;
		mx_internal var showTimer:Timer;
		mx_internal var hideTimer:Timer;
		mx_internal var scrubTimer:Timer;
		mx_internal var currentText:String;
		mx_internal var isError:Boolean;
		mx_internal var previousTarget:DisplayObject;
		private var _currentTarget:DisplayObject;
		public function get currentTarget():DisplayObject;
		public function set currentTarget(value:DisplayObject):void;
		private var _currentToolTip:DisplayObject;
		public function get currentToolTip():IToolTip;
		public function set currentToolTip(value:IToolTip):void;
		private var _enabled:Boolean;
		public function get enabled():Boolean;
		public function set enabled(value:Boolean):void;
		private var _hideDelay:Number;
		public function get hideDelay():Number;
		public function set hideDelay(value:Number):void;
		private var _hideEffect:IAbstractEffect;
		public function get hideEffect():IAbstractEffect;
		public function set hideEffect(value:IAbstractEffect):void;
		private var _scrubDelay:Number;
		public function get scrubDelay():Number;
		public function set scrubDelay(value:Number):void;
		private var _showDelay:Number;
		public function get showDelay():Number;
		public function set showDelay(value:Number):void;
		private var _showEffect:IAbstractEffect;
		public function get showEffect():IAbstractEffect;
		public function set showEffect(value:IAbstractEffect):void;
		private var _toolTipClass:Class;
		public function get toolTipClass():Class;
		public function set toolTipClass(value:Class):void;
		mx_internal function initialize():void;
		public function registerToolTip(target:DisplayObject,oldToolTip:String,newToolTip:String):void;
		public function registerErrorString(target:DisplayObject,oldErrorString:String,newErrorString:String):void;
		private function mouseIsOver(target:DisplayObject):Boolean;
		private function showImmediately(target:DisplayObject):void;
		private function hideImmediately(target:DisplayObject):void;
		mx_internal function checkIfTargetChanged(displayObject:DisplayObject):void;
		mx_internal function findTarget(displayObject:DisplayObject):void;
		mx_internal function targetChanged():void;
		mx_internal function createTip():void;
		mx_internal function initializeTip():void;
		public function sizeTip(toolTip:IToolTip):void;
		mx_internal function positionTip():void;
		mx_internal function showTip():void;
		mx_internal function hideTip():void;
		mx_internal function reset():void;
		public function createToolTip(text:String,x:Number,y:Number,errorTipBorderStyle:String=null,context:IUIComponent=null):IToolTip;
		public function destroyToolTip(toolTip:IToolTip):void;
		mx_internal function showEffectEnded():void;
		mx_internal function hideEffectEnded():void;
		private function getSystemManager(target:DisplayObject):ISystemManager;
		private function getGlobalBounds(obj:DisplayObject,parent:DisplayObject):Rectangle;
		mx_internal function toolTipMouseOverHandler(event:MouseEvent):void;
		mx_internal function toolTipMouseOutHandler(event:MouseEvent):void;
		mx_internal function errorTipMouseOverHandler(event:MouseEvent):void;
		mx_internal function errorTipMouseOutHandler(event:MouseEvent):void;
		mx_internal function showTimer_timerHandler(event:TimerEvent):void;
		mx_internal function hideTimer_timerHandler(event:TimerEvent):void;
		mx_internal function effectEndHandler(event:EffectEvent):void;
		mx_internal function systemManager_mouseDownHandler(event:MouseEvent):void;
		mx_internal function changeHandler(event:Event):void;
		private function marshalToolTipManagerHandler(event:Event):void;
	}
}
