package mx.messaging {
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import mx.core.mx_internal;
	import mx.events.PropertyChangeEvent;
	import mx.logging.Log;
	import mx.messaging.channels.PollingChannel;
	import mx.messaging.events.ChannelEvent;
	import mx.messaging.events.ChannelFaultEvent;
	import mx.messaging.events.MessageEvent;
	import mx.messaging.events.MessageFaultEvent;
	import mx.messaging.messages.AcknowledgeMessage;
	import mx.messaging.messages.CommandMessage;
	import mx.messaging.messages.ErrorMessage;
	import mx.messaging.messages.IMessage;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	public class AbstractConsumer extends MessageAgent {
		public function AbstractConsumer();
		private var _currentAttempt:int;
		private var _resubscribeTimer:Timer;
		protected var _shouldBeSubscribed:Boolean;
		private var _subscribeMsg:CommandMessage;
		private var resourceManager:IResourceManager;
		override mx_internal function setClientId(value:String):void;
		override public function set destination(value:String):void;
		private var _resubscribeAttempts:int;
		public function get resubscribeAttempts():int;
		public function set resubscribeAttempts(value:int):void;
		private var _resubscribeInterval:int;
		public function get resubscribeInterval():int;
		public function set resubscribeInterval(value:int):void;
		private var _subscribed:Boolean;
		public function get subscribed():Boolean;
		protected function setSubscribed(value:Boolean):void;
		private var _timestamp:Number;
		public function get timestamp():Number;
		public function set timestamp(value:Number):void;
		override public function acknowledge(ackMsg:AcknowledgeMessage,msg:IMessage):void;
		override public function disconnect():void;
		override public function fault(errMsg:ErrorMessage,msg:IMessage):void;
		override public function channelConnectHandler(event:ChannelEvent):void;
		override public function channelDisconnectHandler(event:ChannelEvent):void;
		override public function channelFaultHandler(event:ChannelFaultEvent):void;
		public function receive(timestamp:Number=0):void;
		public function subscribe(clientId:String=null):void;
		public function unsubscribe(preserveDurable:Boolean=false):void;
		mx_internal function messageHandler(event:MessageEvent):void;
		protected function buildSubscribeMessage():CommandMessage;
		protected function buildUnsubscribeMessage(preserveDurable:Boolean):CommandMessage;
		protected function resubscribe(event:TimerEvent):void;
		protected function startResubscribeTimer():void;
		protected function stopResubscribeTimer():void;
	}
}
