package mx.messaging {
	import flash.events.EventDispatcher;
	import mx.core.IMXMLObject;
	import mx.core.mx_internal;
	import mx.events.PropertyChangeEvent;
	import mx.logging.ILogger;
	import mx.logging.Log;
	import mx.messaging.FlexClient;
	import mx.messaging.config.ConfigMap;
	import mx.messaging.config.ServerConfig;
	import mx.messaging.errors.InvalidDestinationError;
	import mx.messaging.events.ChannelEvent;
	import mx.messaging.events.ChannelFaultEvent;
	import mx.messaging.events.MessageAckEvent;
	import mx.messaging.events.MessageFaultEvent;
	import mx.messaging.messages.AbstractMessage;
	import mx.messaging.messages.AcknowledgeMessage;
	import mx.messaging.messages.CommandMessage;
	import mx.messaging.messages.ErrorMessage;
	import mx.messaging.messages.IMessage;
	import mx.messaging.messages.MessagePerformanceUtils;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.utils.Base64Encoder;
	import mx.utils.UIDUtil;
	public class MessageAgent extends EventDispatcher implements IMXMLObject {
		mx_internal static const AUTO_CONFIGURED_CHANNELSET:int=0;
		mx_internal static const MANUALLY_ASSIGNED_CHANNELSET:int=1;
		public function MessageAgent();
		protected var _agentType:String;
		protected var _credentials:String;
		protected var _credentialsCharset:String;
		protected var _disconnectBarrier:Boolean;
		private var _pendingConnectEvent:ChannelEvent;
		private var _remoteCredentials:String;
		private var _remoteCredentialsCharset:String;
		private var _sendRemoteCredentials:Boolean;
		protected var _log:ILogger;
		private var _clientIdWaitQueue:Array;
		protected var _ignoreFault:Boolean;
		private var resourceManager:IResourceManager;
		private var _authenticated:Boolean;
		public function get authenticated():Boolean;
		mx_internal function setAuthenticated(value:Boolean,creds:String):void;
		private var _channelSet:ChannelSet;
		public function get channelSet():ChannelSet;
		public function set channelSet(value:ChannelSet):void;
		mx_internal function internalSetChannelSet(value:ChannelSet):void;
		private var _clientId:String;
		public function get clientId():String;
		mx_internal function setClientId(value:String):void;
		private var _connected:Boolean;
		public function get connected():Boolean;
		protected function setConnected(value:Boolean):void;
		private var _destination:String;
		public function get destination():String;
		public function set destination(value:String):void;
		private var _id:String;
		public function get id():String;
		public function set id(value:String):void;
		private var _requestTimeout:int;
		public function get requestTimeout():int;
		public function set requestTimeout(value:int):void;
		private var _channelSetMode:int;
		mx_internal function get channelSetMode():int;
		mx_internal var configRequested:Boolean;
		private var _needsConfig:Boolean;
		mx_internal function get needsConfig():Boolean;
		mx_internal function set needsConfig(value:Boolean):void;
		public function acknowledge(ackMsg:AcknowledgeMessage,msg:IMessage):void;
		public function disconnect():void;
		public function fault(errMsg:ErrorMessage,msg:IMessage):void;
		protected function reAuthorize(msg:IMessage):void;
		public function channelConnectHandler(event:ChannelEvent):void;
		public function channelDisconnectHandler(event:ChannelEvent):void;
		public function channelFaultHandler(event:ChannelFaultEvent):void;
		public function initialized(document:Object,id:String):void;
		public function logout():void;
		public function setCredentials(username:String,password:String,charset:String=null):void;
		public function setRemoteCredentials(username:String,password:String,charset:String=null):void;
		public function hasPendingRequestForMessage(msg:IMessage):Boolean;
		mx_internal function internalSetCredentials(credentials:String):void;
		final protected function assertCredentials(value:String):void;
		final protected function flushClientIdWaitQueue():void;
		protected function internalSend(message:IMessage,waitForClientId:Boolean=true):void;
		protected function initChannelSet(message:IMessage):void;
	}
}
