	package mx.messaging.channels {
		import flash.events.ErrorEvent;
		import flash.events.Event;
		import flash.events.IOErrorEvent;
		import flash.events.SecurityErrorEvent;
		import flash.events.TimerEvent;
		import flash.net.URLLoader;
		import flash.net.URLRequest;
		import mx.core.mx_internal;
		import mx.messaging.FlexClient;
		import mx.messaging.MessageAgent;
		import mx.messaging.MessageResponder;
		import mx.messaging.channels.amfx.AMFXDecoder;
		import mx.messaging.channels.amfx.AMFXEncoder;
		import mx.messaging.channels.amfx.AMFXHeader;
		import mx.messaging.channels.amfx.AMFXResult;
		import mx.messaging.config.ConfigMap;
		import mx.messaging.config.ServerConfig;
		import mx.messaging.errors.MessageSerializationError;
		import mx.messaging.events.ChannelFaultEvent;
		import mx.messaging.messages.AbstractMessage;
		import mx.messaging.messages.AcknowledgeMessage;
		import mx.messaging.messages.AsyncMessage;
		import mx.messaging.messages.CommandMessage;
		import mx.messaging.messages.ErrorMessage;
		import mx.messaging.messages.HTTPRequestMessage;
		import mx.messaging.messages.IMessage;
		import mx.messaging.messages.MessagePerformanceInfo;
		import mx.messaging.messages.MessagePerformanceUtils;
		import mx.utils.ObjectUtil;
		import mx.utils.StringUtil;
		public class HTTPChannel extends PollingChannel {
			public function HTTPChannel(id:String=null,uri:String=null);
			private var _appendToURL:String;
			private var _connectLoader:ChannelRequestLoader;
			private var _encoder:AMFXEncoder;
			private var _pendingRequest:ChannelRequestLoader;
			private var _messageQueue:Array;
			public function get polling():Boolean;
			public function get piggybackingEnabled():Boolean;
			public function set piggybackingEnabled(value:Boolean):void;
			public function get pollingEnabled():Boolean;
			public function set pollingEnabled(value:Boolean):void;
			public function get pollingInterval():Number;
			public function set pollingInterval(value:Number):void;
			override public function get protocol():String;
			mx_internal function get appendToURL():String;
			mx_internal function set appendToURL(value:String):void;
			override public function applySettings(settings:XML):void;
			override protected function connectTimeoutHandler(event:TimerEvent):void;
			override protected function getPollSyncMessageResponder(agent:MessageAgent,msg:CommandMessage):MessageResponder;
			override protected function getDefaultMessageResponder(agent:MessageAgent,msg:IMessage):MessageResponder;
			override protected function internalConnect():void;
			override protected function internalDisconnect(rejected:Boolean=false):void;
			override protected function internalSend(msgResp:MessageResponder):void;
			mx_internal function connectionError(msg:ErrorMessage):void;
			mx_internal function createURLRequest(message:IMessage):URLRequest;
			protected function internalPingComplete(msg:AsyncMessage):void;
			private function AppendToGatewayUrl(value:String):void;
			private function decodePacket(event:Event):AMFXResult;
			private function processHeaders(packet:AMFXResult):void;
			private function pingCompleteHandler(event:Event):void;
			private function pingErrorHandler(event:Event):void;
			private function requestProcessedHandler(loader:ChannelRequestLoader,event:Event):void;
			private static const APPEND_TO_URL_HEADER:String="AppendToGatewayUrl";
		}
	}
	import flash.events.ErrorEvent;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import mx.core.mx_internal;
	import mx.messaging.MessageAgent;
	import mx.messaging.MessageResponder;
	import mx.messaging.channels.HTTPChannel;
	import mx.messaging.channels.amfx.AMFXDecoder;
	import mx.messaging.channels.amfx.AMFXHeader;
	import mx.messaging.channels.amfx.AMFXResult;
	import mx.messaging.messages.AcknowledgeMessage;
	import mx.messaging.messages.AsyncMessage;
	import mx.messaging.messages.CommandMessage;
	import mx.messaging.messages.ErrorMessage;
	import mx.messaging.messages.HTTPRequestMessage;
	import mx.messaging.messages.IMessage;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.utils.StringUtil;
	class HTTPWrapperResponder {
		public function HTTPWrapperResponder(wrappedResponder:MessageResponder);
		private var _wrappedResponder:MessageResponder;
		private var resourceManager:IResourceManager;
		public function completeHandler(event:Event):void;
		public function errorHandler(event:Event):void;
	}
	class HTTPMessageResponder extends MessageResponder {
		public function HTTPMessageResponder(agent:MessageAgent,msg:IMessage,channel:HTTPChannel);
		private var decoder:AMFXDecoder;
		private var resourceManager:IResourceManager;
		public var urlLoader:ChannelRequestLoader;
		override protected function resultHandler(response:IMessage):void;
		override protected function requestTimedOut():void;
		final public function completeHandler(event:Event):void;
		public function errorHandler(event:Event):void;
		public function ioErrorHandler(event:Event):void;
		public function securityErrorHandler(event:Event):void;
	}
	class ChannelRequestLoader {
		public function ChannelRequestLoader();
		private var _urlLoader:URLLoader;
		public var errorCallback:Function;
		public var ioErrorCallback:Function;
		public var securityErrorCallback:Function;
		public var completeCallback:Function;
		public var requestProcessedCallback:Function;
		public function load(request:URLRequest):void;
		public function close():void;
		public function setErrorCallbacks(callback:Function):void;
		private function callRequestProcessedCallback(event:Event):void;
		private function callEventCallback(callback:Function,event:Event):void;
		private function errorHandler(event:Event):void;
		private function ioErrorHandler(event:Event):void;
		private function securityErrorHandler(event:Event):void;
		private function completeHandler(event:Event):void;
	}
	class PollSyncHTTPMessageResponder extends HTTPMessageResponder {
		public function PollSyncHTTPMessageResponder(agent:MessageAgent,msg:IMessage,channel:HTTPChannel);
		override protected function resultHandler(response:IMessage):void;
	}
	class HTTPFireAndForgetResponder extends MessageResponder {
		public function HTTPFireAndForgetResponder(message:IMessage);
	}
