package mx.rpc {
	import flash.events.EventDispatcher;
	import flash.utils.getQualifiedClassName;
	import flash.events.Event;
	import mx.core.mx_internal;
	import mx.logging.ILogger;
	import mx.logging.Log;
	import mx.messaging.errors.MessagingError;
	import mx.messaging.events.MessageEvent;
	import mx.messaging.events.MessageFaultEvent;
	import mx.messaging.messages.AsyncMessage;
	import mx.messaging.messages.IMessage;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.rpc.events.AbstractEvent;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.InvokeEvent;
	import mx.rpc.events.ResultEvent;
	import mx.utils.ObjectProxy;
	import mx.utils.StringUtil;
	import mx.netmon.NetworkMonitor;
	public class AbstractInvoker extends EventDispatcher {
		public function AbstractInvoker();
		private var resourceManager:IResourceManager;
		public function get lastResult():Object;
		public function get makeObjectsBindable():Boolean;
		public function set makeObjectsBindable(b:Boolean):void;
		mx_internal static const BINDING_RESULT:String = "resultForBinding";
		public function cancel(id:String = null):AsyncToken;
		public function clearResult(fireBindingEvent:Boolean = true):void;
		mx_internal function dispatchRpcEvent(event:AbstractEvent):void;
		mx_internal function monitorRpcEvent(event:AbstractEvent):void;
		mx_internal function resultHandler(event:MessageEvent):void;
		mx_internal function faultHandler(event:MessageFaultEvent):void;
		mx_internal function getNetmonId():String;
		mx_internal function invoke(message:IMessage, token:AsyncToken = null):AsyncToken;
		mx_internal function preHandle(event:MessageEvent):AsyncToken;
		mx_internal function processFault(message:IMessage, token:AsyncToken):Boolean;
		mx_internal function processResult(message:IMessage, token:AsyncToken):Boolean;
		mx_internal function get asyncRequest():AsyncRequest;
		mx_internal function set asyncRequest(req:AsyncRequest):void;
		mx_internal var activeCalls:ActiveCalls;
		mx_internal var _responseHeaders:Array;
		mx_internal var _result:Object;
		mx_internal var _makeObjectsBindable:Boolean;
		private var _asyncRequest:AsyncRequest;
		private var _log:ILogger;
	}
}
