package mx.rpc.http {
	import flash.utils.getQualifiedClassName;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	import mx.core.mx_internal;
	import mx.collections.ArrayCollection;
	import mx.logging.ILogger;
	import mx.logging.Log;
	import mx.messaging.ChannelSet;
	import mx.messaging.channels.DirectHTTPChannel;
	import mx.messaging.config.LoaderConfig;
	import mx.messaging.messages.IMessage;
	import mx.messaging.messages.HTTPRequestMessage;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.rpc.AbstractInvoker;
	import mx.rpc.AsyncDispatcher;
	import mx.rpc.AsyncRequest;
	import mx.rpc.AsyncToken;
	import mx.rpc.Fault;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.xml.SimpleXMLDecoder;
	import mx.rpc.xml.SimpleXMLEncoder;
	import mx.utils.ObjectProxy;
	import mx.utils.ObjectUtil;
	import mx.utils.StringUtil;
	import mx.utils.URLUtil;
	public class HTTPService extends AbstractInvoker {
		public static const RESULT_FORMAT_E4X:String = "e4x";
		public static const RESULT_FORMAT_FLASHVARS:String = "flashvars";
		public static const RESULT_FORMAT_OBJECT:String = "object";
		public static const RESULT_FORMAT_ARRAY:String = "array";
		public static const RESULT_FORMAT_TEXT:String = "text";
		public static const RESULT_FORMAT_XML:String = "xml";
		public static const CONTENT_TYPE_XML:String = "application/xml";
		public static const CONTENT_TYPE_FORM:String = "application/x-www-form-urlencoded";
		public static const DEFAULT_DESTINATION_HTTP:String = "DefaultHTTP";
		public static const DEFAULT_DESTINATION_HTTPS:String = "DefaultHTTPS";
		public static const ERROR_URL_REQUIRED:String = "Client.URLRequired";
		public static const ERROR_DECODING:String = "Client.CouldNotDecode";
		public static const ERROR_ENCODING:String = "Client.CouldNotEncode";
		private static var _directChannelSet:ChannelSet;
		private var _log:ILogger;
		private var resourceManager:IResourceManager;
		public var contentType:String;
		public var headers:Object;
		public var method:String;
		public var request:Object;
		private var _resultFormat:String;
		local var _rootURL:String;
		private var _url:String;
		private var _useProxy:Boolean;
		public var xmlDecode:Function;
		public var xmlEncode:Function;
		public function get channelSet():ChannelSet;
		public function set channelSet(value:ChannelSet):void;
		public function get destination():String;
		public function set destination(value:String):void;
		public function get requestTimeout():int;
		public function set requestTimeout(value:int):void;
		public function get resultFormat():String;
		public function set resultFormat(value:String):void;
		public function get rootURL():String;
		public function set rootURL(value:String):void;
		public function get url():String;
		public function set url(value:String):void;
		public function get useProxy():Boolean;
		public function set useProxy(value:Boolean):void;
		public function HTTPService(rootURL:String = null, destination:String = null);
		public function logout():void;
		public function send(parameters:Object = null):AsyncToken;
		public function disconnect():void;
		public function setCredentials(username:String, password:String, charset:String = null):void;
		public function setRemoteCredentials(remoteUsername:String, remotePassword:String, charset:String = null):void;
		function processResult(message:IMessage, token:AsyncToken):Boolean;
		private function decodeArray(o:Object):Object;
		private function decodeParameterString(source:String):Object;
		private function getDirectChannelSet():ChannelSet;
	}
}
